package time_types is
begin logic
  hour :: type(natural) is sel(x::natural | x =< 12 and x>=1);
  minute :: type(natural) is sel(x::natural | x=< 59);
  time :: type(record [h::hour | m::minute]); 

  increment_minutes(t::time)::minute is
    if t(m) < 59 
	  then t(m)+1 
	  else 0
	endif;

  increment_hours(t::time)::hour is
	if t(m) = 59
	  then if t(h) < 12
		   then t(h) + 1 
		   else 1
		   endif
	  else t(h)
	endif;

  increment_time(t::time)::time is
	record [h = increment_hours(t) | m = increment_minutes(t)];
	
end time_types;
