use signalTypes;
use decoder;
package costasLoop is

begin logic
        
facet quadMixer(Iagc,Qagc,Ivco,Qvco::in bitvector12;clk::in
bit;modRate::in integer;Ibb,Qbb::out bitvector12) is

mixer(s1,s2::bitvector12;rate::integer)::bitvector12;

begin state_based

        mixerI:(%clk)=>
		   (Ibb' =mixer(Iagc,Ivco,modRate));

        mixerQ:(%clk)=>
			(Qbb' =mixer(Qagc,Qvco,modRate));

end quadMixer;

facet matchedFilter(Ibb,Qbb::in bitvector12;clk::in bit;modType,modRate::in 
integer;Imf,Qmf::out bitvector12)is
	
	soqpskFilter(s1::bitvector12;rate::integer)::bitvector12;
	sbpskFilter(s1::bitvector12;rate::integer)::bitvector12;
	fskFilter(s1::bitvector12;rate::integer)::bitvector12;
	bpskFilter(s1::bitvector12;rate::integer)::bitvector12;
	deqpskFilter(s1::bitvector12;rate::integer)::bitvector12;
	
begin state_based
	
	filterSoqpsk:(modType = 0) and (%clk) =>
 				(Imf' =soqpskFilter(Ibb,modRate)) and
				(Qmf' =soqpskFilter(Qbb,modRate));
	filterSbpsk:(modType = 1) and (%clk) =>
				(Imf' =sbpskFilter(Ibb,modRate)) and
				(Qmf' =sbpskFilter(Qbb,modRate));
	filterFsk:(modType = 2) and (%clk)  =>
				(Imf' = fskFilter(Ibb,modRate)) and
				(Qmf' =fskFilter(Qbb,modRate));
	filterBpsk:(modType = 3) and (%clk)  =>
				(Imf' =bpskFilter(Ibb,modRate)) and
				(Qmf' =bpskFilter(Ibb,modRate));
	filterDeqpsk:(modType = 4) and (%clk)  =>
				(Imf' =deqpskFilter(Ibb,modRate))and
				(Qmf' =deqpskFilter(Qbb,modRate));
end matchedFilter;


facet lockDetect(Imf,Qmf::in bitvector12;clk::in bit;modRate::in
integer;phaseLock::out bit)is

        getPhaseBit(s1,s2::bitvector12;rate::integer)::bit;

begin state_based

        phaseBit:phaseLock' =getPhaseBit(Imf,Qmf,modRate);

end lockDetect;

facet loopError(Imf,Qmf::in bitvector12;clk::in bit;modType,modRate::in
integer;phaseError::out bitvector12) is


	soqpskPhaseError(s1,s2::bitvector12;rate::integer)::bitvector12;
	sbpskPhaseError(s1,s2::bitvector12;rate::integer)::bitvector12;
        fskPhaseError(s1,s2::bitvector12;rate::integer)::bitvector12;
	bpskPhaseError(s1,s2::bitvector12;rate::integer)::bitvector12;
	deqpskPhaseError(s1,s2::bitvector12;rate::integer)::bitvector12;

begin state_based

        Soqpsk:(modType = 0) and (%clk) =>
              (phaseError' =soqpskPhaseError(Imf,Qmf,modRate));
        Sbpsk:(modType = 1) and (%clk) =>
              (phaseError' = sbpskPhaseError(Imf,Qmf,modRate));
        Fsk:(modType = 2) and (%clk) =>
              (phaseError' = fskPhaseError(Imf,Qmf,modRate));
        Bpsk:(modType = 3) and (%clk) =>
              (phaseError' = bpskPhaseError(Imf,Qmf,modRate));
        Deqpsk:(modType = 4) and (%clk)  =>
              (phaseError' =deqpskPhaseError(Imf,Qmf,modRate));

end loopError;

facet loopFilter(clk::in bit;modType,modRate::in integer;phaseError::in
bitvector12;freqDev::out real)is

	soqpskGetFreqDev(s1::bitvector12;rate::integer)::real;
        sbpskGetFreqDev(s1::bitvector12;rate::integer)::real;
        fskGetFreqDev(s1::bitvector12;rate::integer)::real;
        bpskGetFreqDev(s1::bitvector12;rate::integer)::real;
        deqpskGetFreqDev(s1::bitvector12;rate::integer)::real;

begin state_based

 	soqpsk: (modType = 0) and (%clk) =>
		       (freqDev' = soqpskGetFreqDev(phaseError,modRate));

        sbpsk:(modType = 1) and (%clk) =>
			(freqDev' = sbpskGetFreqDev(phaseError,modRate));

        fsk:(modType = 2) and (%clk)  =>
			(freqDev' = fskGetFreqDev(phaseError,modRate));
        bpsk:(modType = 3) and (%clk)  =>
			 (freqDev' = bpskGetFreqDev(phaseError,modRate));
        deqpsk:(modType = 4) and (%clk) =>
			(freqDev' = deqpskGetFreqDev(phaseError,modRate));

end loopFilter;

facet initPhase(Ibb,Qbb::in bitvector12;clk::in bit;modType,accessType,modRate
::in integer;IDataSamples,QDataSamples::out bitvector12)is

get5single(s1::bitvector12;modtype,rate::integer)::bitvector12;
get25single(s1::bitvector12;modtype,rate::integer)::bitvector12;
get5tdma(s1::bitvector12;modtype,rate::integer)::bitvector12;
get25tdma(s1::bitvector12;modtype,rate::integer)::bitvector12;
get5slave(s1::bitvector12;modtype,rate::integer)::bitvector12;
get25slave(s1::bitvector12;modtype,rate::integer)::bitvector12;

begin state_based
	
	fiveSingle: (accessType = 0) and (%clk) => 
		(IDataSamples' =get5single(Ibb,modType,modRate))and 
		(QDataSamples' =get5single(Qbb,modType,modRate));

        single: (accessType = 1) and (%clk) =>
                (IDataSamples' =get25single(Ibb,modType,modRate)) and 
                (QDataSamples' =get25single(Qbb,modType,modRate));

	fiveTdma: (accessType = 2) and (%clk) =>
                (IDataSamples' = get5tdma(Ibb,modType,modRate)) and
                (QDataSamples' =get5tdma(Qbb,modType,modRate));

	tdma: (accessType = 3) and (%clk) =>
                (IDataSamples' =get25tdma(Ibb,modType,modRate)) and
                (QDataSamples' =get25tdma(Qbb,modType,modRate));

	fiveSlave: (accessType = 4) and (%clk) =>
                (IDataSamples' =get5slave(Ibb,modType,modRate)) and
                (QDataSamples' =get5slave(Qbb,modType,modRate));

	 slave:(accessType = 5) and (%clk) =>
                (IDataSamples' =get25slave(Ibb,modType,modRate)) and
                (QDataSamples' =get25slave(Qbb,modType,modRate));

end initPhase;
export all;
end costasLoop;
