use signalTypes;
use decoder;
package satcomPreprocessorBeh is

begin logic

facet satcomPreprocessorBeh(I,Q::in bitvector12;clk::in
bit;modType,FECRate,uniqueWordType,burstType,accessType,modRate::in integer;
phaseLock,AGCBit,uniqueWordDetect,Idata,Qdata::out bit) is


	resampler(s1::bitvector12;clock::bit;rate::integer)::bitvector12;
	decimator(s1::bitvector12;clock::bit;rate::integer)::bitvector12;
	correctAndDecode(s1::bitvector3;clock::bit;fecrate::integer;
		         rate::integer)::bit;
	sync(s1::bitvector12;clock::bit;rate::integer)::bitvector3;
	phase(s1::bitvector12;clock::bit;rate,form,access::integer)::bitvector12;
	agc(s1::bitvector12;clock::bit;rate::integer)::bitvector12;
	loop(s1,s2::bitvector12;clock::bit;rate,form,access::integer)::bit;
	Ibit,Qbit::bit;
	Ibuffer,Qbuffer::bitvector;
	compare(s1,s2::bitvector;tocompare::bitvector)::bit;
	shift(a::bit;s1::bitvector)::bitvector;
	getTotalPower(a,b::real)::real is a+b;
	threshold::real;
	getUniqueWord(wordtype::integer)::bitvector;

begin state_based

getIbit:(%clk)=>(Ibit'=correctAndDecode(sync(decimator(phase(agc(resampler(I,clk,modRate)
						          ,clk,modRate)
						      ,clk,modRate,modType,accessType)
						,clk,modRate)
				      ,clk,modRate)
				 ,clk,FECRate,modRate));

getQbit:(%clk)=>(Qbit'=correctAndDecode(sync(decimator(phase(agc(resampler(Q,clk,modRate)
                                                          ,clk,modRate)
                                                      ,clk,modRate,modType,accessType)
                                                ,clk,modRate)
                                      ,clk,modRate)
                                 ,clk,FECRate,modRate));

getAGCbit:(%clk)=>(AGCBit'=  % 
			((getTotalPower(getSignalPower(modRate,resampler(I,clk,modRate)),
					getSignalPower(modRate,resampler(Q,clk,modRate))))
                        	> threshold));
 getphaseLock:(%clk)=> (phaseLock'=
			loop(agc(resampler(I,clk,modRate)
				,clk,modRate),
			     agc(resampler(Q,clk,modRate)
                                ,clk,modRate),
			     clk,modRate,modType,accessType));
					

getuniqueWordDetect:(%clk)=>(uniqueWordDetect'=compare(shift(Ibit',Ibuffer),shift(Qbit',Qbuffer),getUniqueWord(uniqueWordType)));

	getIbuffer:Ibuffer'=shift(Ibit',Ibuffer);

	getQbuffer:Qbuffer'=shift(Qbit',Qbuffer);

	getIdata:Idata'=Ibit';

	getQdata:Qdata'=Qbit';


end satcomPreprocessorBeh;

end;
