use signalTypes;
use decoder;
use components;
use accessorFacets;

package satcomPreprocessorStruct is

begin logic

facet satcomPreprocessorStruct(I,Q::in bitvector12;clk::in bit;modType,FECRate
		,uniqueWdType,accessType,modRate,burstType::in integer;
		phaseLock,AGCBit,uniqueWordDetect::out bit) is


	IResampled,QResampled,IDataSamples,QDataSamples,
	IDecimated,QDecimated::bitvector12;
	ISoftDecision,QSoftDecision::bitvector3;
	IData,QData::bit;
	resampleClock,decimatorClock::bit;
	sigNoiseRatio::real;
	moduType::integer;
	erasure:: bit;
begin state_based
	resample:resampler(I,Q,clk,modRate,IResampled,QResampled);

	carrierRecover:carrierRecoveryStruct(IResampled,QResampled,clk,modType,
	modRate,accessType,IDataSamples,QDataSamples,AGCBit,phaseLock);	

	decimate:decimator(IDataSamples,QDataSamples,clk,modRate,IDecimated,
				QDecimated);
	
	synchronize:bitSynchronizer(IDecimated,QDecimated,clk,modRate,
				ISoftDecision,QSoftDecision,erasure);

	errorCorrect:errorCorrectionDecoder(ISoftDecision,QSoftDecision,
				erasure,clk,modRate,FECRate,IData,QData);

	uniqueWord:uniqueWordDetector(IData,QData,modRate,burstType,
		uniqueWdType,clk,uniqueWordDetect);

end satcomPreprocessorStruct;


/*
facet realSatcomPreprocessorStruct(I,Q::in bitvector12;clk::in bit;modType,
FECRate,uniqueWordType,accessType::in bitvector3;modRate::in bitvector4;
burstType::in bitvector2;phaseLock,AGCBit,uniqueWordDetect::out bit) is

modtype,modrate,fecrate,accesstype,uniword,bursttype::integer;

begin state_based

modulationtype:modtype = decodeBitvector3(modType);

modulationrate:modrate = decodeBitvector4(modRate);

fecRate:fecrate = decodeBitvector3(FECRate);

acctype:accesstype = decodeBitvector3(accessType);

uniqueword:uniword = decodeBitvector3(uniqueWordType);

burstTp:bursttype = decodeBitvector2(burstType);

satcomPreprocessor:satcomPreprocessorStruct(I,Q,clk,modtype,modrate,fecrate,
			accesstype,uniword,bursttype,phaseLock,AGCBit,
			uniqueWordDetect);

end;
*/
END;
