package SchmidtTriggerInteraction is

  begin logic

    use Constraints;

    facet schmidt_trigger_interaction(input_voltage:: in real;
                                      output_value:: out bit) is
      b :: bit;
      power :: real;
    begin state_based
      l1: (input_voltage > 0.0) and (input_voltage < 5.0);
      l2: if (input_voltage < 1.0)
            then (b' = 0)
            elseif (input_voltage > 4.0)
                then (b' = 1)
                else (b' = b)
          end if;
      l3: (output_value' = b');
      p1: if (b' == b) then power' = 0.001
                       else power' = power + 0.0005
          end if; 
    end schmidt_trigger_interaction;


end SchmidtTriggerInteraction;
