//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: PrimIntegerAdd.java,v 1.2 2002/11/15 17:22:29 kimmell Exp $
//
// Revision History:
// ----------------
// $Log: PrimIntegerAdd.java,v $
// Revision 1.2  2002/11/15 17:22:29  kimmell
// *** empty log message ***
//
// Revision 1.1.1.1  2002/07/01 15:47:35  cvs
// Rosetta tools and publications repository
//
// Revision 1.1.2.1  2002/03/21 20:25:53  cvs
// Added some functions for dealing with primitive integer arithmetic.
// Made changes to BooleanValue and IntValue fixing a bug in the creation of the values.
// -kimmell
//
package org.sldl.rosetta.lang.functions;

import org.sldl.rosetta.parser.primitive.PrimitiveFunction;
import org.sldl.rosetta.tools.evaluator.Evaluator;
import java.util.List;

import org.sldl.rosetta.ROM.BaseObject;
import org.sldl.rosetta.ROM.Expression;
import org.sldl.rosetta.ROM.ExpressionList;

import org.sldl.rosetta.ROM.Function;



/**
 * PrimIntegerAdd.java
 *
 *
 * Created: Tue Mar 19 16:38:39 2002
 *
 * @author <a href="mailto:kimmell@ku.edu">Garrin Kimmell</a>
 * @version
 */

import org.sldl.rosetta.lang.types.IntType;
import org.sldl.rosetta.lang.values.IntValue;



public class PrimIntegerAdd extends PrimitiveFunction  {
  Function myType;

  public PrimIntegerAdd (){
    /*    ExpressionList type = new ExpressionList();
    type.add(new IntType());
    type.add(new IntType());
    type.add(new IntType());
    myType = new FunctionType(type);
    
    // TODO: Set the correct type of this function
    myType = new FunctionType();
    */
  }
  // implementation of org.sldl.rosetta.parser.primitive.PrimitiveFunction interface

  /**
   *
   * @return <description>
   */
  public String getName()
  {
    // TODO: implement this org.sldl.rosetta.parser.primitive.PrimitiveFunction method
    return "lang.logic.+";
  }

  /**
   *
   * @return <description>
   */
  public Expression getType()
  {
    // TODO: implement this
    // org.sldl.rosetta.parser.primitive.PrimitiveFunction method
    return myType;
  }

  /**
   *
   * @param param1 <description>
   * @param param2 <description>
   * @return <description>
   */
  public Object invoke(List params, Evaluator eval)
  {
    try {
      Object arg1 = params.get(0);
      Object arg2 = params.get(1);
      IntValue val1 = (IntValue) eval.traverse(arg1);
      IntValue val2 = (IntValue) eval.traverse(arg2);
      Integer int1 = (Integer) val1.getPrimitiveValue();
      Integer int2 = (Integer) val2.getPrimitiveValue();
      IntValue result = new IntValue(new Integer(int1.intValue() +
					     int2.intValue()));
      return result;
    
    } catch (Exception e) {
      System.out.println("Evaluation Exception");
      return null;
    } // end of catch
  }

}// PrimIntegerAdd
