//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: MetaParams.java,v 1.2 2002/11/15 17:36:28 kimmell Exp $
//
// Revision History:
// ----------------
// $Log: MetaParams.java,v $
// Revision 1.2  2002/11/15 17:36:28  kimmell
// Updated primitives functions so that the type of the primitive is no longer an instance of FunctionType. FunctionType is no longer present in the ROM, and a Function should be used instead. Currently, the code for setting the type is just commented out. See Bug 260 for the status of this issue.
// -kimmell
//
// Revision 1.1.1.1  2002/07/01 15:47:35  cvs
// Rosetta tools and publications repository
//
// Revision 1.1.2.1  2002/04/17 19:48:07  cvs
// Added primitive meta functions.
// -kimmell
//
package org.sldl.rosetta.lang.functions.meta;

// Java Packages
import java.util.List;

// ROM classes
import org.sldl.rosetta.ROM.Expression;
import org.sldl.rosetta.ROM.ExpressionList;
import org.sldl.rosetta.ROM.Facet;
import org.sldl.rosetta.ROM.Function;
import org.sldl.rosetta.ROM.Item;

// Primitive Base Classes
import org.sldl.rosetta.parser.primitive.PrimitiveFunction;

// Primitive Classes
import org.sldl.rosetta.lang.types.meta.FacetType;

// Tools Classes
import org.sldl.rosetta.tools.evaluator.Evaluator;

/**
 * MetaParams.java
 *
 *
 * Created: Tue Apr  2 13:12:12 2002
 *
 * @author <a href="mailto:kimmell@ku.edu">Garrin Kimmell</a>
 * @version
 */

public class MetaParams extends PrimitiveFunction {
  public MetaParams (){

    myName = "lang.reflect.meta_params";
    /*
    ExpressionList type = new ExpressionList();
    type.add(new FacetType());
    // type.add(new ItemListType());
    myType = new FunctionType(type);
    */
  }
    

  public Object invoke(List params, Evaluator eval) {
    Item arg1 = (Item) params.get(0);
    Facet facet = (Facet) arg1.getValue();
    return facet.getInterfaceItems();
  }
  
}// MetaItems
