//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: BooleanValue.java,v 1.2 2002/07/17 16:50:11 kimmell Exp $
//
// Revision History:
// ----------------
// $Log: BooleanValue.java,v $
// Revision 1.2  2002/07/17 16:50:11  kimmell
// Elimiated the setType in the constructor of each of these classes.
//
// Revision 1.1.1.1  2002/07/01 15:47:35  cvs
// Rosetta tools and publications repository
//
// Revision 1.1.2.3  2002/04/17 19:50:38  cvs
// Modified constructors to accept a Boolean, boolean, or a String representation of the boolean value.
// -kimmell
//
// Revision 1.1.2.2  2002/03/21 20:25:53  cvs
// Added some functions for dealing with primitive integer arithmetic.
// Made changes to BooleanValue and IntValue fixing a bug in the creation of the values.
// -kimmell
//
// Revision 1.1.2.1  2002/03/18 20:20:15  cvs
// Restructured the lang directory to seperate primitive types/values/functions.
// -kimmell
//
// Revision 1.1.2.1  2002/03/12 22:30:48  cvs
// Added classes representing primitive rosetta types in Java.
// -kimmell
//
package org.sldl.rosetta.lang.values;

/**
 * BooleanValue.java
 *
 *
 * Created: Thu Mar  7 15:14:17 2002
 *
 * @author <a href="mailto:kimmell@ku.edu">Garrin Kimmell</a>
 * @version
 */

import org.sldl.rosetta.parser.primitive.PrimitiveValue;
import org.sldl.rosetta.lang.types.BooleanType;

public class BooleanValue extends PrimitiveValue {
    
    public BooleanValue (String argValue) {
      //setType(new BooleanType());
	value = Boolean.valueOf(argValue);
    }
    
    public BooleanValue(boolean argValue) {
      //setType(new BooleanType());
	value = new Boolean(argValue);
    } 
    
    public boolean booleanValue() {
	return ((Boolean)value).booleanValue();
    }
    
}// BooleanValue
