//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: RealValue.java,v 1.2 2002/07/17 16:50:11 kimmell Exp $
//
// Revision History:
// ----------------
// $Log: RealValue.java,v $
// Revision 1.2  2002/07/17 16:50:11  kimmell
// Elimiated the setType in the constructor of each of these classes.
//
// Revision 1.1.1.1  2002/07/01 15:47:35  cvs
// Rosetta tools and publications repository
//
// Revision 1.1.2.3  2002/06/05 16:36:44  kimmell
// Added a "add" method that will add the current value to a RealValue passed as a parameter.
// -kimmell
//
// Revision 1.1.2.2  2002/04/17 19:51:10  cvs
// Modified RealValue to accept a Double, double, or a String representing the value.
// -kimmell
//
// Revision 1.1.2.1  2002/03/18 20:20:18  cvs
// Restructured the lang directory to seperate primitive types/values/functions.
// -kimmell
//
// Revision 1.1.2.1  2002/03/12 22:30:49  cvs
// Added classes representing primitive rosetta types in Java.
// -kimmell
//
package org.sldl.rosetta.lang.values;

/**
 * RealValue.java
 *
 *
 * Created: Thu Mar  7 16:02:16 2002
 *
 * @author <a href="mailto:kimmell@ku.edu">Garrin Kimmell</a>
 * @version
 */

import org.sldl.rosetta.parser.primitive.PrimitiveValue;
import org.sldl.rosetta.lang.types.RealType;

public class RealValue extends PrimitiveValue {

  public RealValue(String argValue) {
    value = Double.valueOf(argValue);
    // setType(new RealType());
  }

  public RealValue(double argValue) {
    value = new Double(argValue);
    // setType(new RealType());
  }

  public RealValue(Double argValue) {
    value = argValue;
    // setType(new RealType());
  }
  
  public void add(RealValue argValue) {
    value = new Double(((Double)value).doubleValue() +
		       ((Double)argValue.getPrimitiveValue()).doubleValue());
    //    value = ((Double)value).plus(argValue.getPrimitiveValue());
  }
}// RealValue
