//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: StringValue.java,v 1.3 2002/10/22 17:10:35 cvs Exp $
//
// Revision History:
// ----------------
// $Log: StringValue.java,v $
// Revision 1.3  2002/10/22 17:10:35  cvs
// Made a minor change in the toString() method.Removed the preceeding and the following quotes while returning the value in String form.
// --Murthy.
//
// Revision 1.2  2002/07/17 16:50:11  kimmell
// Elimiated the setType in the constructor of each of these classes.
//
// Revision 1.1.1.1  2002/07/01 15:47:35  cvs
// Rosetta tools and publications repository
//
// Revision 1.1.2.2  2002/06/05 16:37:31  kimmell
// 1. Added a toString() method.
// 2. Added an equals() method.
// -kimmell
//
// Revision 1.1.2.1  2002/03/18 20:20:18  cvs
// Restructured the lang directory to seperate primitive types/values/functions.
// -kimmell
//
// Revision 1.1.2.1  2002/03/12 22:30:50  cvs
// Added classes representing primitive rosetta types in Java.
// -kimmell
//
package org.sldl.rosetta.lang.values;

/**
 * StringValue.java
 *
 *
 * Created: Thu Mar  7 16:14:27 2002
 *
 * @author <a href="mailto:kimmell@ku.edu">Garrin Kimmell</a>
 * @version
 */

import org.sldl.rosetta.parser.primitive.PrimitiveValue;
import org.sldl.rosetta.lang.types.StringType;

public class StringValue extends PrimitiveValue {
  public StringValue (Object argValue){
    value = argValue;
    // setType(new StringType());
    
  }

  public String toString() {
    try {
      //Commented by Murthy to be compatible with DVTG.
      //return "\"" + value.toString() + "\"";
      return  value.toString();
    } catch (Exception e) {
      return "Unknown Value";
    } // end of catch
    
  }

  public BooleanValue equals(StringValue target) {
    if (((String)target.getPrimitiveValue()).equals(value)) {
      return new BooleanValue(true);
    } else {
      return new BooleanValue(false);
    } // end of else
  }

    
}// StringValue
