package org.sldl.rosetta.parser.linker.symboltable;

import java.util.Vector;

public class DefaultBasicSymbolTable implements BasicSymbolTable
  {
  private final BasicSymbolTableEntry tableRoot;
  private BasicSymbolTableEntry currentEntry;


  public DefaultBasicSymbolTable(Object rootObject)
    {
    tableRoot = new DefaultBasicSymbolTableEntry(rootObject);
    currentEntry = tableRoot;
    }


  public String toString()
    { return entryString(tableRoot, ""); }
  public final static String indentString = "  ";
  private String entryString(BasicSymbolTableEntry scope, String depth)
    {
    int pos;
    String result;

    if (scope == null)
      { return ""; }

    result = depth + scope.toString() + "\n";
    for (pos = 0; pos < scope.getChildCount(); pos++)
      { result = result + entryString(scope.getEntryAt(pos), depth + indentString); }
    return result;
    }


  public void enterScope(Object childTarget)
    { currentEntry = currentEntry.getChildEntry(childTarget); }

  public void revokeScope()
    { currentEntry = currentEntry.getParentEntry(); }

  public void resetToRoot()
    { currentEntry = tableRoot; }


  public BasicSymbolTableEntry getRootEntry()
    { return tableRoot; }

  public BasicSymbolTableEntry getCurrentEntry()
    { return currentEntry; }

  public BasicSymbolTableEntry getCurrentParent()
    { return currentEntry.getParentEntry(); }


  public void addChild(Object childObject)
    { currentEntry.addChild(childObject); }

  public void addChildEntry(BasicSymbolTableEntry childEntry)
    { currentEntry.addChildEntry(childEntry); }

  public BasicSymbolTableEntry resolveReference(String match)
    { return currentEntry.resolveReference(match); }
  }

