package org.sldl.rosetta.parser.primitive;

/**
 * PrimitiveFunction.java
 *
 *
 * Created: Tue Jan 15 11:58:32 2002
 *
 * @author <a href="mailto:kimmell@ku.edu">Garrin Kimmell</a>
 * @version
 */

import java.util.List;
import java.util.LinkedList;

import org.sldl.rosetta.tools.evaluator.Evaluator;
import org.sldl.rosetta.ROM.Expression;
import org.sldl.rosetta.ROM.Function;
// import org.sldl.rosetta.ROM.FunctionType;

public abstract class PrimitiveFunction extends Function
  implements Primitive, PrimitiveProvider {


  protected Expression myType;
  protected String myName;

  /**
   * The <code>getName</code> method returns the Rosetta object that
   * this class should be bound to. 
   *
   * @return a <code>String</code> value
   */
  public String getName() {
    return myName;
  }

  /**
   * The <code>getType</code> method returns the type 
   * (a -> b -> ... -> n) of this function.
   *
   * @return an <code>Expression</code> value
   */
  public Expression getType() {
    return myType;
  }
  
  /**
   * The <code>invoke</code> method performs an application of this
   * given function call.
   *
   * @param args a <code>BaseObject[]</code> value
   * @return a <code>BaseObject</code> value
   */
  public abstract Object invoke(List args, Evaluator eval);

  /* PrimitiveProvider implementation */
  
  public List getPrimitives() {
    List l = new LinkedList();
    
    l.add(this);
    return l;
  }
  
    
}
  
// PrimitiveFunction
