package org.sldl.rosetta.parser.primitive;

/**
 * PrimitiveLoader.java
 *
 *
 * Created: Fri Jan 18 10:29:10 2002
 *
 * @author <a href="mailto:kimmell@ku.edu">Garrin Kimmell</a>
 * @version
 */


import java.io.*;
import java.util.List;
import java.util.LinkedList;
import java.util.Iterator;
import org.sldl.rosetta.ROM.Item;
import org.sldl.rosetta.ROM.BaseObject;
import org.sldl.rosetta.ROM.Expression;

public class PrimitiveLoader {

  Item tree;

  public PrimitiveLoader (Item argTree){
    tree = argTree;
  }


  public void loadFile(FileReader file) {
    BufferedReader reader = new BufferedReader(file);
    String className;
    List primitives;
    try {
      while ((className = reader.readLine()) != null) {
	// Cut out comments
	className = className.trim();
	int commentBegin = className.indexOf("//");
	if (commentBegin != -1) {
	  className = className.substring(0,commentBegin);
	} // end of if (commentBegin != -1)
	className = className.trim();
	
	if (! className.equals("")) {
	  
	  try {
	    
	    Class theClass = Class.forName(className);
	    PrimitiveProvider provider = (PrimitiveProvider) theClass.newInstance();
	    primitives = provider.getPrimitives();
	    for (Iterator primIter = primitives.iterator(); primIter.hasNext();){
	      addPrimitive((Primitive) primIter.next());
	    } // end of for (Iterator primIter = primitives.iterator();
	    // primIter.hasNext();)
	  } catch (ClassNotFoundException e) {
	    System.out.println("Could not find Primitve class " + className);
	  } catch (InstantiationException e) {
	    System.out.println("Could not instantiate Primitive class "
			       + className);
	  } catch (IllegalAccessException e) {
	    System.out.println("Could not call getPrimitives() on " + className);
	  } // end of catch
	  
	} // end of while ((className = reader.readLine()) != null)
      }
    } catch (IOException ioe) {
      
    } // end of try-catch
  }

  private void addPrimitive(Primitive prim) {

    Item theItem = findItem(prim.getName());
    if (theItem == null) {
      System.out.println("PrimitiveLoader: " + prim.getName() + " was not found.");
    } else if (theItem.getValue() != null) {
      System.out.println("PrimitiveLoader: Can not rebind primitive"
			 + prim.getName());
    } else {
      theItem.setValue((Expression)prim);
    } // end of else
      
  }
  
  private Item findItem(String name) {
    return null;
  }



}// PrimitiveLoader
