//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: PrimitiveType.java,v 1.1.1.1 2002/07/01 15:47:36 cvs Exp $
//
// Revision History:
// ----------------
// $Log: PrimitiveType.java,v $
// Revision 1.1.1.1  2002/07/01 15:47:36  cvs
// Rosetta tools and publications repository
//
// Revision 1.1.2.1  2002/03/12 22:32:41  cvs
// Modified the primitive system to include primitive types and primitive values. This allows us to represent basic Rosetta types in Java. Additionally, primtive functions can be defined that will allow evaluation of Rosetta.
// -kimmell
//
package org.sldl.rosetta.parser.primitive;

import java.util.List;
import java.util.LinkedList;

import org.sldl.rosetta.ROM.Expression;
import org.sldl.rosetta.ROM.TypeExpression;

/**
 * PrimitiveType.java
 *
 *
 * Created: Thu Mar  7 12:57:02 2002
 *
 * @author <a href="mailto:kimmell@ku.edu">Garrin Kimmell</a>
 * @version
 */

public abstract class PrimitiveType extends TypeExpression 
  implements Primitive, PrimitiveProvider {
  public PrimitiveType (){
    
  }

  /* Primitive implementation */
  public abstract String getName();

  public Expression getType() {
    return this; 
  }
  

  /* PrimitiveProvider implementation */
  
  public List getPrimitives() {
    List l = new LinkedList();
    
    l.add(this);
    return l;
  }
  
  public boolean equals(Object inValue) {
    return getClass().equals(inValue.getClass());
  }

    

}// PrimitiveType
