//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: PrimitiveValue.java,v 1.2 2002/07/17 16:43:39 kimmell Exp $
//
// Revision History:
// ----------------
// $Log: PrimitiveValue.java,v $
// Revision 1.2  2002/07/17 16:43:39  kimmell
// 1. Added dummy getType and setType methods to compensate for their
// removal from Expression. This is a temporary fix.
//
// Revision 1.1.1.1  2002/07/01 15:47:36  cvs
// Rosetta tools and publications repository
//
// Revision 1.1.2.1  2002/03/12 22:32:41  cvs
// Modified the primitive system to include primitive types and primitive values. This allows us to represent basic Rosetta types in Java. Additionally, primtive functions can be defined that will allow evaluation of Rosetta.
// -kimmell
//
package org.sldl.rosetta.parser.primitive;

import org.sldl.rosetta.ROM.BaseObject;
import org.sldl.rosetta.ROM.Expression;
import org.sldl.rosetta.ROM.ExpressionList;
import org.sldl.rosetta.ROM.ItemList;

/**
 * PrimitiveValue.java
 *
 *
 * Created: Thu Mar  7 12:43:43 2002
 *
 * @author <a href="mailto:kimmell@ku.edu">Garrin Kimmell</a>
 * @version
 */

public class PrimitiveValue extends Expression {


  protected Object value = null;

  public PrimitiveValue() {
    value = null;
  }

  public PrimitiveValue (Object argValue){
    value = argValue;
  }

  public Object getPrimitiveValue() {
    return value;
  }

  public String publishROM(String str) {
    return str + value;
  }

  public String toString() {
    try {
      return value.toString();
    } catch (Exception e) {
      return "Unknown Value";
    } // end of catch
    
  }

  // These next two type functions are to be eliminated
  // (7/16/02). They're here because expression remove the getType and
  // setType methods.
  public void setType() {
  }

  public Expression getType() {
    return null;
  }

  // Dummy methods 
  public boolean matches(BaseObject obj, 
			 BaseObject[] lhsHistory, 
			 BaseObject[] rhsHistory) {
    try {
      PrimitiveValue prim = (PrimitiveValue) obj;
      return value.equals(prim.getPrimitiveValue());

    } catch (Exception e) {
      return false;
    } // end of try-catch
  }

  public Expression instantiate(ItemList formals, 
				ExpressionList actuals) {
    return this;
  }



  
}// PrimitiveValue
