/* the purpose of this file is to:
(i) testing the parsing capabilities of the (antlr) parser with Rosetta code conforming to the Accellera standard
(ii) to guide developers in the general Accellera Rosetta syntax
*/

use testfile1.uses.this;
facet testfile1(/*can have no signature*/)::"all" /*domain here - just an expression*/ is
	/*use clauses in ident.ident format*/
	use test_facet.uses.this;
	facet test_facet()::dom=>"domain" /*domain is an expression*/ is
		//variable declarations
		s::bit;
	begin
		/*terms
		//this type of comment is within a delimiter and ignored anyway
		*/
		ta: if 2 then 3 elsif 4 then 5 elsif 6 then 7 else 8 end if;
		t1: t2>>>16\AF\+4.1E+9;
		t3: a=>b=>c;
		t4: y@t+5=s';
		t4: s'=y@t+2;
		term5: f(this[that(theother)]*5)&term6;
		term6: "string"&'c'&"oncaten""ation"&'u+0020'/*space*/&'U+3041'/*hiragana 'a', just showing use of Unicode specifier*/;
		/*let_expression within a term
		t2: let (a::integer be 5, b::complex be j,c::character be '.') in
			e()
			end let;
		/*let_term*/
		let(b::integer be ((x*g)/z)^m ) in
			t1: b=<0;
			t2: b>=0;
		end let;
	end facet;

	use my_domain.uses.this;
	use my_domain.uses.this.also, this.used.within.my_domain;
	domain my_domain (upper, lower::limits 5)::"domain" is
		/*export clauses, "all" or ident.ident ...etc*/
		export all;
		currentTime::time;
	begin
		term1: currentTime<epoch;
		term2: currentTime>endOfTime;
		term3: upper>lower;
		term4: term1 & term2 & term3=>true;
		//example of type declarations
		universal_type: type;
		subtype_type: subtype(subt);
		set_type: set(st);
		array_type: array(at);
	end domain my_domain;

	package test_package(xyz,abc,fgh,ijk::label_1 16\A\; var::my_var 5)::"domain" is
		export all;
	begin //test_package
	end package test_package;
	
	component this_component (depth, breadth, height::distance "cm")::"domain" is
		export all;
		//no declarations this time
	begin //this_component
		//component assumptions
		assumption
			ass_t1: my_domain.term4;
			ass_21: depth>=0 & breadth>=0 & height>=0;
		end assumption;
		//component definitions
		definition
			surfaceArea: 2*(breadth*height + height*depth + depth*breadth);
			volume: breadth*depth*height;
		end definition;
		//component implications
		implication
			i1:volume>=0;
			i2:surfaceArea>=0;
		end implication;
	end component this_other_component;

begin //testfile1

	//nothing, just wrapping the four declarations in a single facet
	/*undecided as yet whether a single .sld file may contain multiple declaration units*/

end facet testfile1;
