//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
// Revision History:
// ----------------
// $Log: BooleanTerm.java,v $
// Revision 1.2  2002/09/09 15:21:59  cvs
// Added KU License to all the files and made some minor changes.
// --Murthy.
//
package org.sldl.rosetta.tools.generatedata;

import java.lang.*;
import java.util.LinkedList;
import java.util.Iterator;
/**
 * BooleanTerm.java
 *
 *
 * Created: Mon Feb 11 10:28:55 2002
 *
 * @author <a href="mailto:zwang@kirk.ittc.ku.edu">Zhongjun Wang</a>
 * @version
 */

public class BooleanTerm extends LinkedList{

  private String termName;
  
  /**
   * Creates a new <code>BooleanTerm</code> instance.
   *
   */
  public BooleanTerm (){
    termName = "";
  }
  
  /**
   * Creates a new <code>BooleanTerm</code> instance.
   *
   * @param nameInput a <code>String</code> value
   */
  public BooleanTerm (String nameInput){
    termName = nameInput;
  }

  public BooleanTerm(BooleanTerm copy) {
    for (Iterator copyIter = copy.iterator(); copyIter.hasNext();)
      {
	add(copyIter.next());
      }
  }

  /**
   * Describe <code>GettermName</code> method here.
   *
   * @return a <code>String</code> value
   */
  public String getTermName(){
    return termName;
  }
 
  /**
   * Describe <code>SettermName</code> method here.
   *
   * @param nameInput a <code>String</code> value
   */
  public void setTermName(String nameInput){
    termName = nameInput;
  }
 
  /**
   * The <code>getValue</code> method returns the value of the term,
   * if it is true, 1 is returned, otherwise, 0 is returned.
   *
   * @return an <code>int</code> value
   */
  public int getValue(){
   int value = 1;

   if ( size() != 0)
     { 
       for (int i = 0; i < size(); i++)
	 {
	   int n = ( (BooleanVariable) get(i)).getValue();
	   //System.out.print(" value in getvalue "+ n ); 
	   value = value * n;
	 }
       return value;
     }
   else
     return value = 88;
  }
 
  /**
   * The<code>isTrue</code> method returns true if the term is true,
   * otherwise, it returns false.
   *
   * @return a <code>boolean</code> value
   */
  public boolean isTrue(){
    int value = 1;

    if ( size() != 0)
      value = getValue();

    if ( (value == 1) && (size() !=0) ) 
      return true;
    else 
      return false;

  }
  /**
   * Describe <code>toString</code> method here.
   *
   * @return a <code>String</code> value
   */
 
  public String toString(){
    String str = "";
    for (Iterator iter = iterator(); iter.hasNext();) {
      str = str + iter.next().toString();
    }
    return str;
  }

  public String printExpr(){
    String str = "";
    boolean first = true;
    for (Iterator iter = iterator(); iter.hasNext();) {
      str = str + ( first ? "" : " and ");
      first = false;
      str = str +  ((BooleanVariable)iter.next()).printExpr();
    }
    return str;
  }

  public LinkedList getBooleanVarList(){
    LinkedList boolVarList = new LinkedList();
    for (Iterator iter = iterator();iter.hasNext();) {
      boolVarList.add(iter.next());
    } // end of for (Iterator iter = iterator();iter.hasNext();)
    return boolVarList;
  }


  /**
   * Describe <code>main</code> method here.
   *
   * @param args a <code>String[]</code> value
   */
  public static void main(String[] args){
    BooleanVariable a,b,c,cbar;
    a = new BooleanVariable("a",1);
    b = new BooleanVariable("b",1);
    c = new BooleanVariable("c",1);

    BooleanTerm abc;

    abc = new BooleanTerm("abc");

    abc.add(a);
    abc.add(b);
    abc.add(c.getComplement().getComplement());
    
    cbar = c.getComplement();

    abc.set(2,cbar);

    abc.set(2,cbar.getComplement());

    abc.set(0,a.getComplement());

    System.out.println(" term name " + abc);
    
    System.out.println(" term value " + abc.getValue());

    c.setValue(0);
    System.out.println(" size of list " + abc.size());
    System.out.println(" true or false " +  abc.isTrue());

    System.out.println(" term contains c? "+ abc.contains(c));
    System.out.println(" term contains cbar? "+ abc.contains(cbar));

  } 

}// BooleanTerm
