//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: FormulaList.java,v 1.4 2002/11/11 18:18:50 ksatya Exp $
// Revision History:
// ----------------
// $Log: FormulaList.java,v $
// Revision 1.4  2002/11/11 18:18:50  ksatya
// Removed DataLiteral from FormulaList and added NumberLiteral.
//
// Revision 1.3  2002/09/09 15:22:00  cvs
// Added KU License to all the files and made some minor changes.
// --Murthy.
//

package org.sldl.rosetta.tools.generatedata;

import java.lang.*;
import java.util.*;

import org.sldl.rosetta.ROM.*;

/**
 * FormulaList.java
 *
 *
 * Created: Fri Feb 22 15:19:40 2002
 *
 * @author <a href="mailto:zwang@kirk.ittc.ku.edu">Zhongjun Wang</a>
 * @version
 */

public class FormulaList extends LinkedList {

  private String name;

  public FormulaList (){
    super();
    name="";
  }
  public FormulaList(String nameInput){
    super();
    name = nameInput;
  }

  public String getName(){
    return name;
  }
  public void setName(String nameInput){
    name = nameInput;
  }
  //  public void add(Formula formulaInput){
  //  add(formulaInput);
  //}

  public static void main(String args[]){
    
    
    Label labge = new Label(">=");
    Item tstItem = new Item(labge,null,null,null);
    ItemReference tstItmRefGe = new ItemReference(tstItem);

    Label labeq = new Label("=");
    Item tstItemeq = new Item(labeq,null,null,null);
    ItemReference tstItmRefEq = new ItemReference(tstItemeq);

    
    //    Formula app2 = new Formula(new StringLiteral("x"),new
    //    DataLiteral(new Boolean("5.0")),tstItmRefGe);
    ExpressionList params = new ExpressionList();
    params.add(new ItemReference("x"));
    //params.add(new DataLiteral(new Double(5.0)));
    Application app2 = new Application(tstItmRefEq, params);

    params = new ExpressionList();
    params.add(new ItemReference("x"));
    //params.add(new DataLiteral(new Double(3.0)));
    Application app3 = new Application(tstItmRefEq, params);


    FormulaList test = new FormulaList();

    test.add(app2);
    test.add(app3);

    for (int i = 0; i< test.size(); i++)
      {
	
	System.out.println(" The "+i+" -th formula in list");
	System.out.println("The left operand is:"+
			   ((Application)test.get(i)).getParameters().get(0));
	System.out.println("The right operand is:"+
			   ((Application)test.get(i)).getParameters().get(1));
	System.out.println("The operator is:"+
			   ((Application)test.get(i)).getFunction());
	
	//System.out.println("The right operand is:"+((Formula)test.get(i) ).getRightOp());
	//System.out.println("The operator is: "+ ( (Formula)test.get(i)).getOperator());
	
      }
  }
  
}// FormulaList
