//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: GenerateScenarios.java,v 1.13 2002/11/18 12:06:32 ksatya Exp $
//
// Revision History:
// ----------------
// $Log: GenerateScenarios.java,v $
// Revision 1.13  2002/11/18 12:06:32  ksatya
// Removed the debugging statement for the declared terms in a Facet.
// --Murthy.
//
// Revision 1.12  2002/11/18 11:57:46  ksatya
// Removed the debugging statements from all the files.
// --Murthy.
//
// Revision 1.11  2002/11/13 01:53:02  ksatya
// Added changes to generate scenarios for inner facets in a facet and multiple for multiple facets in a Package.
// --Murthy.
//
// Revision 1.9  2002/11/06 05:55:55  ksatya
// Implemented the initial functionality of reading the requirements from an XML file.Needs to be thoroughly tested...
// --Murthy.
//
// Revision 1.8  2002/10/22 20:17:55  cvs
// Made some minor changes while printing the scenarios file.Included all the conditions in the terms in parenthesis.
// --Murthy.
//
// Revision 1.7  2002/10/14 20:23:40  cvs
// Made changs to iterate through bits.
// --Murthy.
//
// Revision 1.6  2002/10/14 13:10:03  cvs
// Bits need to be handled seperately for generating the vectprs.Changes are made to support them.
// --Murthy.
//
// Revision 1.5  2002/10/08 14:33:56  cvs
// Made the tools compatable to generate the false points in XML format.Added a new file ValueGenerator.java to generate the vectors.This file implements a new logic as compared to the logic in GenerateVectors class.
// --Murthy.
//
// Revision 1.4  2002/09/03 15:31:27  cvs
// Made changes to make the DVTG tool compliant with the new ROM structure.Also added new clasess to make the functionality more flexible.
// --Murthy.
//
// Revision 1.3  2002/07/10 02:12:09  cvs
// Enhancements made to support the "alarm" directory in generating the scenarios.
// --Murthy.
//
// Revision 1.2  2002/07/09 21:29:02  cvs
// Added all the boolean operators.Fixed bugs for checking the arithmetic
// operators.Removed stuff that is not being used.
// --Murthy.
//
// Revision 1.1.1.1  2002/07/01 15:47:36  cvs
// Rosetta tools and publications repository
//
// Revision 1.1.2.10  2002/06/06 16:41:23  cvs
// Removed the debugging statements.
// --Murthy.
//
// Revision 1.1.2.9  2002/06/04 14:57:15  cvs
// Made changes to the source to generate the WAVES format.
// --Murthy
//
// Revision 1.1.2.8  2002/05/13 22:47:42  cvs
// Added the file ReadTestRequirements for implementing the basic functionality
// of generating the vectors from test requirements.
// --Murthy.
//
// Revision 1.1.2.7  2002/04/29 01:34:00  cvs
// Implemented the basic functionality of generating the cost function from the false points.
// --Murthy.
//
// Revision 1.1.2.6  2002/04/26 01:12:06  cvs
// Implemented the functionality of generating the fasle points.
// --Murthy.
//
// Revision 1.1.2.4  2002/04/18 16:48:17  cvs
// 1. Fixed a bug with the creation of DNF expressions.
// 2. Added the printing of near-false points to GenerateData.
// 3. Fixed a bug in the constructor of BooleanVariable which caused a StackOverflowException.
// -wang
//
// Revision 1.1.2.3  2002/04/17 16:52:43  cvs
// Added the recursive generation of test scenarios into DNF form.
// -wang
//
// Revision 1.1.2.2  2002/04/17 16:06:17  cvs
// Made changes to DVTG code to generate DNF expressions from Rosetta.
// -wang
//
// Revision 1.1.2.1  2002/04/11 20:40:48  cvs
// Initial checking of test scenario generation stuff.
// -kimmell
// 
package org.sldl.rosetta.tools.generatedata;

import org.sldl.rosetta.ROM.*;
import org.sldl.rosetta.tools.testparser.TestParser;
import org.sldl.rosetta.tools.multivisitor.MultiVisitor;
import org.sldl.rosetta.lang.values.*;


import java.lang.*;
import java.util.*;
import java.util.Iterator;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.io.FileNotFoundException;
import java.io.IOException;
/**
 * GenerateScenarios.java
 *
 *
 * Created: Thu Apr 11 14:54:06 2002
 *
 * @author <a href="mailto:kimmell@ku.edu">Garrin Kimmell</a>
 * @version
 */

public class GenerateScenarios extends MultiVisitor {
  /**
   * Describe variable <code>newFacet</code> here.
   *
   */
  private Facet newFacet;
  private int variableCount = 0;

  //This variblae contains the scenarios before the removal 
  // of redundancy.
  private LinkedList scenarios;

  //This variable contains the scenarios after the removal of 
  //redundancy.
  private LinkedList finalScenarios;
  private DnfExpression dnfExpr;

  private LinkedList innerFacetScenarios;
  private boolean innerFacet = false;
  public PrintWriter pw;


  /**
   * Creates a new <code>GenerateScenarios</code> instance.
   * The Primary Constructor.
   */
  public GenerateScenarios (){
    newFacet = new Facet();
    toolName = "DVTG";
    scenarios = new LinkedList();
    finalScenarios = new LinkedList();
    innerFacetScenarios = new LinkedList();
  }


  public void instantiatePrintWriter(String nameIn) {
    try {
      FileOutputStream fout = new FileOutputStream(nameIn);    
      pw = new PrintWriter(fout,true);
    } catch (FileNotFoundException e) {
      
    } // end of try-catch
  }

  public PrintWriter getPrintWriter() {
    return pw;
  }
    
  /**
   * Describe <code>setDNF</code> method here.
   *
   * @param dnfExprIn a <code>DnfExpression</code> value
   */
  public void setDNF(DnfExpression dnfExprIn)
  {
    dnfExpr = dnfExprIn;
  }

  public void setPrintWriter(PrintWriter pwIn) {
    pw = pwIn;
  }



  /**
   * Describe <code>getVariableName</code> method here.
   *
   * @return a <code>String</code> value
   */
  private String getVariableName() {
    String str =   "a" + (new Integer(variableCount + 1)).toString();
    variableCount = variableCount + 1;
    return str;
 }



  /**
   * Describe <code>getScenarios</code> method here.
   *
   * @return a <code>LinkedList</code> value
   */
  public LinkedList getScenarios() {
    return scenarios;
  }

  /**
   * Describe <code>process</code> method here.
   *
   * @param f a <code>Facet</code> value
   */
  //public void process(Facet f) {
  public void process(Item fctItm) {
    Expression current;
    Object currentReturn;
    ItemList returnItems;
    LinkedList facetScenarios = new LinkedList();
    
    
    Facet f = (Facet)fctItm.getValue();
        
    pw.print("facet "+fctItm.getLabel());

    //To print the interface items in the facet.
    printFacetParameters(f);
    
    //To print the declared items in the facet.
    Item declItem = null;
    for (Iterator declIter = f.getDeclaredItems().iterator(); 
	 declIter.hasNext();) {

      declItem = (Item)declIter.next();

      if (declItem.getValue() instanceof Facet) {
	process(declItem);
	
      } // end of if (declItem.getValue() instanceof Facet)
      else {
	printFacetDeclaredItems(declItem);
      } // end of else
      
    } // end of for (Iterator declsIter = f.getDeclaredItems().iterator(); declIter.hasNext())
    
    //To Print the Domain of the Facet.
    pw.println("begin "+f.getDomain());

    //publishFacet(fctItm);
    for (Iterator termIter = f.getTermItems().iterator(); termIter.hasNext();){
      current = (Expression)((Item)termIter.next()).getValue();
      DnfExpression dnfExpr = (DnfExpression)traverse(current);
      //System.out.println(dnfExpr);
      printFacetTerms(dnfExpr);    
      //facetScenarios.add(dnfExpr);
    }
    pw.println("end;");

  }
  
  
  /**
   * Describe <code>process</code> method here.
   *
   * @param app an <code>Application</code> value
   * @return an <code>Object</code> value
   */
  public Object process(Application app) {
    
    //System.out.println("I am in Application");
    return makeDNF(app);
  }
  
  /**
   * Describe <code>process</code> method here.
   *
   * @param ref an <code>ItemReference</code> value
   * @return an <code>Object</code> value
   */
  public Object process(ItemReference ref) {
    //System.out.println("I am in itemreference");
    return makeDNF(ref);
  }
  
  
  /**
   * Describe <code>process</code> method here.
   * 
   * @param ifExpr an <code>IfExpression</code> value
   * @return an <code>Object</code> value
   */
  public Object process(IfExpression ifExpr) {
    GenerateVectors.generateFalsePoints = true;
    List termList = new LinkedList();
    IfWrapper ifWrap = new IfWrapper(ifExpr);
    ifWrap.processIfsThens();
    if (ifWrap.ifThenCount() > 0) {
      
      BooleanTerm nots = new BooleanTerm();
      LinkedList ifs = ifWrap.getIfs();
      //ExpressionList thens = ifExpr.getThens();
      LinkedList thens = ifWrap.getThens();
      Expression elseExpr = (Expression)ifWrap.getElse();
      
      BooleanTerm temp;
      BooleanVariable antecedent;
      DnfExpression consequent;
      
      LinkedList terms = new LinkedList();
      LinkedList booleanVariables = new LinkedList();
      
      for (int i = 0; i < ifWrap.ifThenCount(); i++) {
	
	//Dealing with the if part.
	Application ifApp = (Application)ifs.get(i);
	String ifOper = ifApp.getFunction().toString();
	String param = ifApp.getParameters().get(0).toString();
	//System.out.println("The parameter is: "+param);
	if (ifOper.equals("%")) {
	  double value = 0.0;
	  ExpressionList parameters = new ExpressionList();
	  parameters.add(new StringValue(param));
	  //parameters.add(param);
	  parameters.add(new RealValue(value));
	  Application newApp = new Application(new ItemReference(">"),parameters,Application.BINARY);
	  //System.out.println("The new application is: "+newApp);
	  antecedent = new BooleanVariable(getVariableName(),0,newApp);
	}
	else {
	  antecedent = new BooleanVariable(getVariableName(), 0,
					   (Expression)ifs.get(i));  
	} // end of else
	booleanVariables.add(antecedent);
	//System.out.println("The Then part is: "+thens.get(i));
	consequent = (DnfExpression) traverse(thens.get(i));
	// Add the boolean variables from the recursive call to the 
	// list of all boolean variables.
	booleanVariables.addAll(0, consequent.getSymbolsList());
	
	consequent.propogate(antecedent);
	consequent.propogate(nots);
	for (Iterator consIter = consequent.iterator(); consIter.hasNext();){
	  termList.add(consIter.next());
	} 
	nots.add(antecedent.getComplement());
	// log(MESSAGE, "Nots is " + nots.toString());
      }
      
      DnfExpression elseDNF = (DnfExpression) traverse(elseExpr);
      // Add the boolean variables from the recursive call to the
      // list of all boolean variables.
      booleanVariables.addAll(0, elseDNF.getSymbolsList());
      
      elseDNF.propogate(nots);
      for (Iterator elseIter = elseDNF.iterator(); elseIter.hasNext();){
	termList.add(elseIter.next());
      }
      
      // Create the Dnf Expression
      
      DnfExpression DNFexpr = new DnfExpression("newName", booleanVariables);
      for(Iterator termIter = termList.iterator(); termIter.hasNext();) {
	BooleanTerm boolTerm = (BooleanTerm)termIter.next();
	//scenarios.add((BooleanTerm)boolTerm);
	DNFexpr.add((BooleanTerm) boolTerm);
      }
      
      //log(MESSAGE, "DNF Expression: " + DNFexpr);
      //log(MESSAGE, "Vector: " + DNFexpr.printExpr());
      //log(MESSAGE, "Near False Points: ");
      //DNFexpr.nearFalsePoints();
      
      this.setDNF(DNFexpr);
      return DNFexpr;
    } else {
      return null;
    }
  }
  
  
  
  
  /**
   * Describe <code>makeDNF</code> method here.
   *
   * @param e an <code>Expression</code> value
   * @return a <code>DnfExpression</code> value
   */
  public DnfExpression makeDNF(Expression e) {
    //System.out.println("The expression is: "+e);
    BooleanTerm term = new BooleanTerm();
    LinkedList varNames = new LinkedList();
    String function =((Application)e).getFunction().toString();
    //System.out.println("The function is: "+function);
    if (function.equals("and") || function.equals("=>")) {
      LinkedList tempVarList = new LinkedList();
      LinkedList boolVarList = seperateVariables(e,tempVarList);
      for (Iterator iter = boolVarList.iterator();iter.hasNext();) {
	BooleanVariable boolVar = new BooleanVariable(getVariableName(),0,(Expression)iter.next());
	term.add(boolVar);
	varNames.add(boolVar);
      }
    }
    else {
      BooleanVariable var = new BooleanVariable(getVariableName(), 0,e);
      term.add(var);
      varNames.add(var);
    }
    DnfExpression expr = new DnfExpression("", varNames);
    expr.add(term);
    
    if (innerFacet == true) {
      innerFacetScenarios.add(term);       
    } // end of if (innerFacet == true)
    else {
      scenarios.add(term);
    } // end of else
    
    
    return expr;
  }
  
  
  /**
   * Describe <code>seperateVariables</code> method here.
   * by Murthy. in some cases the boolean term is 
   * considered as a boolean variable.So this method takes a 
   * boolean term and splits it into boolean variables.
   * @param e an <code>Expression</code> value
   * @param varList a <code>LinkedList</code> value
   * @return a <code>LinkedList</code> value
   */
  public static LinkedList seperateVariables(Expression e,LinkedList varList)
  {
    Application termApp = (Application)e;
    ExpressionList variableList = (ExpressionList)termApp.getParameters();
    Iterator varListIter = variableList.iterator();
    Object leftOp = varListIter.next();
    if (leftOp instanceof Application) {
      String leftOper = (String)((Application)leftOp).getFunction().toString();
      if (isBoolean(leftOper)) {
	seperateVariables((Expression)leftOp,varList); 
      }
      else {
	varList.add((Expression)leftOp);
      }
    }
    Object rightOp = varListIter.next();
    varList.add(rightOp);
    return varList;  
  }
  
  /**
   * Describe <code>isBoolean</code> method here.
   *
   * @param oper a <code>String</code> value
   * @return a <code>boolean</code> value
   */
  public static boolean isBoolean(String oper) {
    if (oper.equals("and") || oper.equals("nand") || oper.equals("min") || oper.equals("nmin") || oper.equals("=>")) {
      return true;
    }
    else {
      return false;
    }
  }
  
  
  /**
   * Describe <code>publishPackage</code> method here.
   * This method basically displays the cotents of the
   * interface items, declared items and terms in the facet
   * to the filename_VECTORS.sld file.
   * --Murthy.
   * @param pw a <code>PrintWriter</code> value
   * @param packItem an <code>Item</code> value
   */
  public void publishPackage(Item packItem)
  {
    boolean hasIntrItems = false;
    org.sldl.rosetta.ROM.Package pack = (org.sldl.rosetta.ROM.Package)packItem.getValue();
    pw.print("package "+packItem.getLabel());
    
    //***************************************************************//
    //Dealing with the interface items in a Package.
    ItemList packIntrList = pack.getInterfaceItems();
    Iterator packIntrIter = packIntrList.iterator();
    if (packIntrIter.hasNext()) {
      hasIntrItems = true;
      pw.print("(");
    } // end of if (packInteIter.hasNext())
    
    while (packIntrIter.hasNext()) {
      Item intrItem = (Item)packIntrIter.next();
      pw.print(intrItem.getLabel()+"::");
      if (intrItem.getDecoration("kind") != null) {
	pw.print(intrItem.getDecoration("kind"));
      } // end of if (intrItem.getMode() != null)
      
      pw.print(" "+intrItem.getType());
      if (packIntrIter.hasNext()) {
	pw.print(";");
      } // end of if (packIntrIter.hasNext())
      
    } // end of while (packDeclIter.hasNext())
    if (hasIntrItems == true) {
      pw.println(") is");       
    } // end of if (hasInteItems == true)
    else {
      pw.println(" is");
    } // end of else
    //******************************************************************//
    
    pw.println("begin "+pack.getDomain().toString());
    
    //Dealing with the Declared Items in a package.
    ItemList packDeclItems = pack.getDeclaredItems();
    Iterator packDeclItemsIter = packDeclItems.iterator();
    
    while (packDeclItemsIter.hasNext()) {
      Item fctItem = (Item)packDeclItemsIter.next();
      
      //  if (fctItem.getValue() instanceof Function) {
      //  	pw.println(((Function)fctItem.getValue()).publishROM(fctItem.getLabel()," "));
      //        } // end of if (fctItem.getValue() instanceof Function)
      
      //The declared items can be a Facet or any standard Item Declaration.
      if (fctItem.getValue() instanceof Facet) {
	//pw.print("facet "+fctItem.getLabel());
	//publishFacet(fctItem,pw);
      }
      else {
	if (fctItem.getValue() instanceof Function) {
	  pw.println(((Function)fctItem.getValue()).publishROM(fctItem.getLabel()," ")+";");
	} // end of if (fctItem.getValue() instanceof Function)
	
	else {
	  pw.print(fctItem.getLabel()+"::"+fctItem.getType());
	  if (fctItem.getValue() != null) {
	    pw.println(" is "+fctItem.getValue()+";"); 
	  } // end of if (fctItem.getValue() != null)
	  else {
	    pw.println(";");
	  } // end of else
	}	
      } // end of else
    }
    //pw.println("end;");
  }
  
  
  
  //public void publishFacet(Facet fct) {
  public void printFacetParameters(Facet fct) {
    boolean hasIntrItems = false;
    //pw.print("facet "+fctItem.getLabel());
    //Facet fct = (Facet)fctItem.getValue();
    
    //****************************************************************//
    //Dealing with the interface items in the facet.
    ItemList fctIntrList = fct.getInterfaceItems();
    Iterator fctIntrIter = fctIntrList.iterator();
    if (fctIntrIter.hasNext()) {
      hasIntrItems = true;
      pw.print("(");
    } // end of if (packInteIter.hasNext())
    
    while (fctIntrIter.hasNext()) {
      Item fctIntrItem = (Item)fctIntrIter.next();
      pw.print(fctIntrItem.getLabel()+"::");
      if (fctIntrItem.getDecoration("kind") != null) {
	pw.print(fctIntrItem.getDecoration("kind"));
      } // end of if (intrItem.getMode() != null)
      pw.print(" "+fctIntrItem.getType());
      if (fctIntrIter.hasNext()) {
	pw.print(";");
      }
    }
    if (hasIntrItems == true) {
      pw.println(") is");       
    } // end of if (hasInteItems == true)
    else {
      pw.println(" is");       
    } // end of else
  }
  
  //*****************************************************************//
  
  //****************************************************************//
  //Dealing with the Declared Items in the Facet.
  
  public void printFacetDeclaredItems(Item fctDeclItem){
    pw.println(fctDeclItem.publishROM()+";");
    //  pw.print(fctDeclItem.getLabel()+"::"+fctDeclItem.getType());
//      if (fctDeclItem.getValue() != null) {
//        pw.println(" is "+fctDeclItem.getValue()+";");
//      } // end of if (fctDeclItem.getValue() != null)
//      else {
//        pw.println(";");
//      } // end of else
  }
  
  //******************************************************************//
  
  public void printFacetTerms(DnfExpression dnfExpr) {
    
    //******************************************************************//
    //Dealing with the Terms in the facet.    
    int index = 1;//Used to keep track of the index for the 
    //number if terms in the facet.
    
    //for (Iterator iter = scenarios.iterator();iter.hasNext();) {
      for (Iterator iter = dnfExpr.iterator();iter.hasNext();) {
      
      BooleanTerm scenTerm = (BooleanTerm)iter.next();
      RedundancyRemoving redRem = new RedundancyRemoving(scenTerm);
      
      //for every scenario the redundancy has to be removed.
      LinkedList newScen = redRem.redundancyRemoval();
      
      //Storing the LinkedList in the finalScenarios variable.
      finalScenarios.add(newScen);
      
      //Iterate through the scenario and print all the nodes
      //in the scenario.
      Iterator scenTermIter = newScen.iterator();
      pw.print("ACCEPT_"+index+++":");	 
      
      while (scenTermIter.hasNext()) {
	Object boolVar = scenTermIter.next();
	if (boolVar instanceof Application) {
	  if (boolVar.toString().startsWith("(") || boolVar.toString().endsWith(")")) {
	    pw.print(boolVar.toString());
	  } // end of if (boolVar.toString().startsWith("(") || boolVar.toString().endsWith(")"))
	  else {
	    pw.print("("+boolVar.toString()+")");	     
	  } // end of else
	  if (scenTermIter.hasNext()) {
	    pw.print(" and ");
	  } // end of if (scenTermIter.hasNext())
	} // end of if (boolVar instanceof BooleanVariable)
      } // end of for (Iterator iter = scenarios.iterator();iter.hasNext())
      pw.println(";");
    }
    //######################################################################//
    

  }
  
  
  public void printFacet(Item fctItem) {
    
    pw.print("facet "+fctItem.getLabel()+"(");
    Facet fct = (Facet)fctItem.getValue();
    //****************************************************************//
    //Dealing with the interface items in the facet.
    ItemList fctIntrList = fct.getInterfaceItems();
    Iterator fctIntrIter = fctIntrList.iterator();
    while (fctIntrIter.hasNext()) {
      Item fctIntrItem = (Item)fctIntrIter.next();
      pw.print(fctIntrItem.getLabel()+"::");
      if (fctIntrItem.getDecoration("kind") != null) {
	pw.print(fctIntrItem.getDecoration("kind"));
      } // end of if (intrItem.getMode() != null)
      pw.print(" "+fctIntrItem.getType());
      if (fctIntrIter.hasNext()) {
	pw.print(";");
      }
    }
    pw.println(") is");

    //****************************************************************//
    //Dealing with the Declared Items in the Facet.
    ItemList fctDeclItemList = fct.getDeclaredItems();
    Iterator fctDeclItemsIter = fctDeclItemList.iterator();
    while (fctDeclItemsIter.hasNext()) {
      Item fctDeclItem = (Item)fctDeclItemsIter.next();  
      pw.print(fctDeclItem.getLabel()+"::"+fctDeclItem.getType());
	if (fctDeclItem.getValue() != null) {
	  pw.println(" is "+fctDeclItem.getValue()+";");
	} // end of if (fctDeclItem.getValue() != null)
	else {
	  pw.println(";");
	} // end of else
	 } // end of while (fctDeclItemsIter.hasNext())
    
    //Dealing with the domain of the facet.
    pw.println("begin "+fct.getDomain().toString());
    
    //} // end of while (packDeclItemsIter.hasNext())
    //******************************************************************//
    
    //******************************************************************//
    //Dealing with the Terms in the facet.    
    int index = 1;//Used to keep track of the index for the 
    //number if terms in the facet.
    
    //for (Iterator iter = scenarios.iterator();iter.hasNext();) {
    for (Iterator iter = innerFacetScenarios.iterator();iter.hasNext();) {
            
      BooleanTerm scenTerm = (BooleanTerm)iter.next();
      RedundancyRemoving redRem = new RedundancyRemoving(scenTerm);
      
      //for every scenario the redundancy has to be removed.
      LinkedList newScen = redRem.redundancyRemoval();
      
      //Storing the LinkedList in the finalScenarios variable.
      finalScenarios.add(newScen);
      
      //Iterate through the scenario and print all the nodes
      //in the scenario.
      Iterator scenTermIter = newScen.iterator();
      pw.print("ACCEPT_"+index+++":");	 
      
      while (scenTermIter.hasNext()) {
	Object boolVar = scenTermIter.next();
	if (boolVar instanceof Application) {
	  if (boolVar.toString().startsWith("(") || boolVar.toString().endsWith(")")) {
	    pw.print(boolVar.toString());
	  } // end of if (boolVar.toString().startsWith("(") || boolVar.toString().endsWith(")"))
	  else {
	    pw.print("("+boolVar.toString()+")");	     
	  } // end of else
	  if (scenTermIter.hasNext()) {
	    pw.print(" and ");
	  } // end of if (scenTermIter.hasNext())
	} // end of if (boolVar instanceof BooleanVariable)
      } // end of for (Iterator iter = scenarios.iterator();iter.hasNext())
      pw.println(";");
    }
    //######################################################################//
    
    pw.println("end;");
  }



   /**
   * Describe <code>main</code> method here.
   *
   * @param args a <code>String[]</code> value
   */
  public static void main (String[] args)  {
    
    pseudoMain(args[0]);
  }

  public static void pseudoMain(String arg) {

    GenerateScenarios genScen = new GenerateScenarios();     
    //*****************************************************************//
    //To compile the input test file.
    org.sldl.rosetta.tools.testparser.TestParser testparser = new org.sldl.rosetta.tools.testparser.TestParser();
    Item packItem = testparser.compileFile(arg);
    //for (int index = 0; index < itemList.size(); index++) {


    //****************************************************************//
    //This prints the scenarios to a file.The filename is 
    //rootword_SCENARIOS.sld
    //try {
    //FileOutputStream fout = new FileOutputStream(args[0].substring(0,args[0].indexOf(".sld"))+"_SCENARIOS.sld");    
    //PrintWriter pw = new PrintWriter(fout,true);
    //genScen.publishPackage(pw,packItem);
    //} catch (FileNotFoundException e) {
      
    //} // end of try-catch
    //****************************************************************//
    //genScen.setPrintWriter(pw);    
    //genScen.pw = pw;
    genScen.instantiatePrintWriter(arg.substring(0,arg.indexOf(".sld"))+"_SCENARIOS.sld");
    genScen.publishPackage(packItem);

    //Item packItem = itemList.get(index);
      org.sldl.rosetta.ROM.Package pack = (org.sldl.rosetta.ROM.Package)packItem.getValue();
      //*****************************************************************//
      
      
      //******************************************************************//
      //Walking through the tree for the package.
      ItemList declItemList = pack.getDeclaredItems();
      Iterator declIter = declItemList.iterator();
      while (declIter.hasNext()) {
	Item fctItem = (Item)declIter.next();
	if (fctItem.getValue() instanceof Facet) {
	  //genScen.process((Facet)(fctItem.getValue()));  	 
	  genScen.process(fctItem);  	 
	} // end of if (Item instanceof Facet)
      } // end of while (declIter.hasNext())
      //*******************************************************************//
      
      genScen.pw.println("end;");
      

      
      //} // end of for (int index = 0; index < ItemList.size(); index++)
    //****************************************************************//
    //Dealing with the False Point Generation stuff.
    //  FalsePointsGenerator falsePointGen = new FalsePointsGenerator(genScen.getScenarios());
    //      falsePointGen.buildFalsePoints();
    //      falsePointGen.setDirectoryName(args[0].substring(0,args[0].indexOf(".sld")));
    //      falsePointGen.generateFalsePoints();
    //      falsePointGen.instantiateCostFunction();
    //*****************************************************************//
  } // end of main ()
}

    

