//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: XmlWaves.java,v 1.2 2002/09/09 15:22:00 cvs Exp $
//
// Revision History:
// $Log: XmlWaves.java,v $
// Revision 1.2  2002/09/09 15:22:00  cvs
// Added KU License to all the files and made some minor changes.
// --Murthy.
//

package org.sldl.rosetta.tools.generatedata;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;


import org.w3c.dom.Document;
import org.xml.sax.SAXException;

import java.io.File;
import java.io.IOException;

public class XmlWaves {

  static Document doc;

  public static void main (String[] argv) {
    try {
      DocumentBuilderFactory dFactory =  DocumentBuilderFactory.newInstance(); 
      DocumentBuilder dBuilder = dFactory.newDocumentBuilder(); 
      File file = new File(argv[1]); 
       doc = dBuilder.parse(file);
    } catch (ParserConfigurationException e) {
      
    } catch (SAXException e) {
      
    } catch (IOException e) {
      
    } // end of catch
    try {
      File styleSheet = new File(argv[0]);
      StreamSource styleSource = new StreamSource(styleSheet);
      TransformerFactory factory = TransformerFactory.newInstance();
      Transformer transformer = factory.newTransformer(styleSource);

      DOMSource source = new DOMSource(doc);
      StreamResult result = new StreamResult(System.out);
      transformer.transform(source,result);

    } catch (TransformerConfigurationException e) {
      
    } catch (TransformerException e) {
       
    } // end of catch
    
    

    
  } // end of main ()
}
