//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: Container.java,v 1.1 2002/09/27 05:18:39 cvs Exp $
// Revision History:
// ----------------
// $Log: Container.java,v $
// Revision 1.1  2002/09/27 05:18:39  cvs
// This is the scanner for the DVTG Expressions.These files are used to evaluate
// the expressions.
// --Murthy.
//

package org.sldl.rosetta.tools.generatedata.scanner;

/**
 * Describe class <code>Container</code> here.
 *
 * @author <a href="mailto:ksatya@ittc.ku.edu">Murthy Kakarlamudi</a>
 * @version 1.0
 */
public class Container {
  
  private Operator operator;
  private Operand operand;

  /**
   * Creates a new <code>Container</code> instance.
   *
   */
  public Container() {
  }

  /**
   * Creates a new <code>Container</code> instance.
   *
   * @param operandIn an <code>Operand</code> value
   * @param operatorIn an <code>Operator</code> value
   */
  public Container(Operand operandIn, Operator operatorIn) {
    operand = operandIn;
    operator = operatorIn;
  }

  /**
   * Describe <code>setOperands</code> method here.
   *
   * @param operandIn an <code>Operand</code> value
   */
  public void setOperands(Operand operandIn) {
    operand = operandIn;
  }

  /**
   * Describe <code>getOperands</code> method here.
   *
   * @return an <code>Operand</code> value
   */
  public Operand getOperands() {
    return operand;
  }

  /**
   * Describe <code>setOperators</code> method here.
   *
   * @param operatorIn an <code>Operator</code> value
   */
  public void setOperators(Operator operatorIn) {
    operator = operatorIn;
  }

  /**
   * Describe <code>getOperators</code> method here.
   *
   * @return an <code>Operator</code> value
   */
  public Operator getOperators() {
    return operator;
  }

  /**
   * Describe <code>display</code> method here.
   *
   */
  public void display() {
    System.out.println("Displaying the operands");
    operand.displayOperands();
 
    System.out.println("Displaying the operators");
    operator.displayOperators();
  }
}
