<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:strip-space elements="vector"/>

<xsl:template match="/">
	<xsl:text>%</xsl:text>
	<xsl:apply-templates select="/vectorslist/vector[1]/condition/parameter"/>
	<xsl:text>
	</xsl:text>
	<xsl:apply-templates select="/vectorslist/vector"/>
	<xsl:text>
	</xsl:text>
</xsl:template>



<xsl:template match="/vectorslist/vector">
	<xsl:apply-templates select="condition/value">
	</xsl:apply-templates>
	<xsl:text>
	</xsl:text>
</xsl:template>

<xsl:template match="/vectorslist/vector[1]/condition/parameter">
	<xsl:call-template name="strip-parens">
	<xsl:with-param name="text" select="."/>
	</xsl:call-template>
</xsl:template>

<xsl:template match="condition/value">
	<xsl:call-template name="strip-parens">
	<xsl:with-param name="text" select="."/>
	</xsl:call-template>
	<xsl:text>&#9;</xsl:text>
</xsl:template>

<xsl:template name="strip-open-parens">
  <xsl:param name="text" />
  <xsl:choose>
  <xsl:when test="contains($text, '(' )">
    <xsl:value-of select="substring-before($text, '(')"/>
    <xsl:call-template name="strip-open-parens">
      <xsl:with-param name="text" 
                      select="substring-after($text, '(')"/>
    </xsl:call-template>
 </xsl:when>
  <xsl:otherwise>
    <xsl:value-of select="$text"/>
 
  </xsl:otherwise>
 
  </xsl:choose>
</xsl:template>

<xsl:template name="strip-close-parens">
  <xsl:param name="text" />
  <xsl:choose>
  <xsl:when test="contains($text, ')' )">
    <xsl:value-of select="substring-before($text, ')')"/>
    <xsl:call-template name="strip-close-parens">
      <xsl:with-param name="text" 
                      select="substring-after($text, ')')"/>
    </xsl:call-template>
  </xsl:when>
 <xsl:otherwise>
    <xsl:value-of select="$text"/>
  </xsl:otherwise>
 
  </xsl:choose>
</xsl:template>

<xsl:template name="strip-parens">
  <xsl:param name="text"/>
   <xsl:call-template name="strip-close-parens">
    <xsl:with-param name="text">
        <xsl:call-template name="strip-open-parens">
             <xsl:with-param name="text"
                             select="$text"/>
        </xsl:call-template>
    </xsl:with-param>
   </xsl:call-template>
</xsl:template>
  
                    


</xsl:stylesheet>
