//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: LiteralType.java,v 1.1 2002/09/29 02:47:42 cvs Exp $
// Revision History:
// ----------------
// $Log: LiteralType.java,v $
// Revision 1.1  2002/09/29 02:47:42  cvs
// Added the directory "types" to support the different types in DVTG.
// --Murthy.
//
// Revision 1.3  2002/09/27 05:22:04  cvs
// Implemented the complete functionality of BitVectors.
// --Murthy.
//
// Revision 1.2  2002/09/09 15:22:00  cvs
// Added KU License to all the files and made some minor changes.
// --Murthy.
//


package org.sldl.rosetta.tools.generatedata.types;

import org.sldl.rosetta.ROM.Application;
import org.sldl.rosetta.lang.values.RealValue;
import org.sldl.rosetta.tools.generatedata.GenerateVectors;


import java.util.LinkedList;
import java.util.Iterator;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import java.io.FileNotFoundException;
import java.io.FileNotFoundException;
import java.io.PrintWriter;

public class LiteralType implements Type {
  
  private float initial_value;
  private float final_value;
  private float increment;
  private String input_var;
  private HashMap inputs;
  
  public LiteralType(float initIn,float finalIn,float incIn) {
    initial_value = initIn;
    final_value = finalIn;
    increment = incIn;
  }

  public LiteralType(HashMap inputsMapIn) {
    Set set  = inputsMapIn.entrySet();
    Iterator setIter = set.iterator();
    while (setIter.hasNext()) {
      Map.Entry entry = (Map.Entry)setIter.next();
      System.out.println("The key class name is: "+entry.getKey().getClass().getName());
      System.out.println("The entry value is: "+entry.getKey().toString());
      input_var = (String)entry.getKey().toString();
      LinkedList values = (LinkedList)entry.getValue();
      initial_value = new Float(values.get(0).toString()).floatValue();
      final_value = new Float(values.get(1).toString()).floatValue();
      increment = new Float(values.get(2).toString()).floatValue();
      this.displayInitialFinals();
    } // end of while (setIter.hasNext())  
  }
  
  public Object getInitialValue() {
    return (new Float(initial_value));
  }
  
  public Object getFinalValue() {
    return (new Float(final_value));
  }
  
  public Object getIncrement() {
    return (new Float(increment));
  }
  
  public void setInputs(HashMap inputsIn) {
    inputs = inputsIn;
  }

  public LinkedList buildInitialFinals() {
    LinkedList initFinList = new LinkedList();
    initFinList.add(new Float(initial_value));
    initFinList.add(new Float(final_value));
    initFinList.add(new Float(increment));
    
    return initFinList;
  }
  
  public void buildVectors(LinkedList finalList,PrintWriter pw, PrintWriter xmlPw) throws FileNotFoundException {
    
    int index = 1;
    System.out.println("I came into the SetType");
    
    //This method call is used to convert the initial and final
    //values in bitvector type to the corresponding integer values.
   //   LinkedList initFinalLst = this.buildInitialFinals();
    
//      int count = 0;//This count is used as the index value.
//      String tmpInit = (String)initFinalLst.get(count).toString();
//      String tmpFinal = (String)initFinalLst.get(count+1).toString();
//      String tmpInc = (String)initFinalLst.get(count+2).toString();
    
//      //The following lines of code generates the integer 
//      //values from the bitvectors in String.
//      int initialValue = Byte.parseByte(tmpInit,2);
//      int finalValue = Byte.parseByte(tmpFinal,2);
//      int incrementValue = (new Integer(tmpInc)).intValue();
    
    xmlPw.println("<vectorslist>");
    for (float iptVar = initial_value;iptVar <= final_value;iptVar = iptVar+increment) {

	  System.out.println("in the for loop");
	  int flag = 1;
	  for (Iterator outerIter = finalList.iterator();outerIter.hasNext();) {
	    LinkedList innerList = (LinkedList)outerIter.next();
	    for (Iterator innerIter = innerList.iterator();innerIter.hasNext();) {
	      Application app = (Application)innerIter.next();
	      String leftOp = app.getParameters().get(0).toString();
	      String operator = app.getFunction().toString();
	      System.out.println("in the inner list:"+leftOp+"  "+operator);
	      if (app.getParameters().get(1) instanceof RealValue) {
		String rightOperand = app.getParameters().get(1).toString();
		float rightOp = (new Float(rightOperand)).floatValue();
		//System.out.println("The rightOp is: "+rightOp);
		if (input_var.equals(leftOp)) {
		  if (((operator.equals("=")) && (iptVar == rightOp)) || ((operator.equals("<")) &&(iptVar < rightOp)) || ((operator.equals(">")) && (iptVar > rightOp)) ) {
		    
		    //Printing the vectors in text format.
		    GenerateVectors.printVectors(iptVar,innerList,pw);
				//Printing the vectors in XML format.
		    GenerateVectors.printXml(iptVar,innerList,xmlPw,index);
		    index++;
		    flag = 0;
		    break;
		  }
	    }
	      }
	    }
	    if (flag == 0) {
	      break;
	    }
	    
	  }
    }
    xmlPw.println("</vectorslist>");
  }

  public void displayInitialFinals() {
    System.out.println("The initial value is: "+initial_value);
    System.out.println("The final value is: "+final_value);
    System.out.println("The increment is: "+increment);
  }
}


