package org.sldl.rosetta.tools.generatedata.types;

import org.sldl.rosetta.ROM.Application;
import org.sldl.rosetta.ROM.ArrayValue;

import java.io.PrintWriter;
import java.io.FileNotFoundException;
import java.util.LinkedList;
import java.util.Iterator;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import java.util.BitSet;

import org.sldl.rosetta.tools.generatedata.values.*;
import org.sldl.rosetta.tools.generatedata.scanner.DVTGScanner;
import org.sldl.rosetta.tools.generatedata.scanner.Container;
import org.sldl.rosetta.tools.generatedata.scanner.Operand;
import org.sldl.rosetta.tools.generatedata.scanner.ParseException;
import org.sldl.rosetta.tools.generatedata.scanner.Operator;

public class Sets {

  private HashMap inputs;
  
  public Sets(HashMap inputsIn) {
    inputs = inputsIn;
    Set sets = inputs.entrySet();
    Iterator setIter = sets.iterator();
    Map.Entry entry = (Map.Entry)setIter.next();
    System.out.println("Key: "+entry.getKey()+" Value:"+entry.getValue());
  }

  public void buildVectors(LinkedList finalList,PrintWriter pw,PrintWriter xmlPw)throws FileNotFoundException {
    
    for (Iterator outerIter = finalList.iterator();outerIter.hasNext();) {
      LinkedList innerList = (LinkedList)outerIter.next();

      for (Iterator innerIter = innerList.iterator();innerIter.hasNext();) {
	Application app = (Application)innerIter.next();
	//xmlPw.println("<vectorslist>");
	evaluateExpression(app,pw,xmlPw);
	//xmlPw.println("</vectorslist>");
      } // end of for (Iterator innerIter = innerList.iterator();innerIter.hasNext();)
      
    } // end of for (Iterator outerIter = finalList.iterator();outerIter.hasNext();)
  }

  public void evaluateExpression(Application appIn,PrintWriter pw,PrintWriter xmlPw) {
    
    LinkedList finalList = new LinkedList();
    try {
      
      DVTGScanner parser = new DVTGScanner(appIn.toString());
      Container cont = parser.scan();
      

      //This needs to be fixed.There is some discrepency in
      //the naming convention.
      Operand operands = cont.getOperands();
      LinkedList operandsList = operands.getOperands();
      
      Operator operator = cont.getOperators();
      LinkedList operatorsList = operator.getOperatorList();
      
      if (operatorsList.size() == 0) {
	String left_key = operandsList.getFirst().toString();
	LinkedList left_value = (LinkedList)inputs.get(left_key);
	ArrayValue left_value_tmp = (ArrayValue)left_value.getFirst();

	printText(left_value_tmp,pw,operands);
	printXml(left_value_tmp,xmlPw,operands);
	
      } // end of if (operatorsList == 0)
    }     catch (ParseException e) {
      System.out.println("Error in parsing the expression");
    } // end of try-catch
  }
  

  public void printText(ArrayValue valueIn, PrintWriter textIn,Operand operandIn) {
    for (int count = 0; count < valueIn.size(); count++) {
      LinkedList operandsList = operandIn.getOperands();
      for (Iterator operIter = operandsList.iterator(); operIter.hasNext();) {
	textIn.print(operIter.next()+" = ");
	textIn.print(valueIn.getElementAt(count));
      }
      textIn.print("\t");
      textIn.print(operandIn.getLeftOperand()+" = ");
      textIn.println(valueIn.getElementAt(count));
    } // end of for (int count = 0; count < valueIn.size(); count++)
  }

  public void printXml(ArrayValue valueIn, PrintWriter xmlPw, Operand operandIn) {
    for (int count = 0; count < valueIn.size(); count++) {
      LinkedList operandsList = operandIn.getOperands();
      xmlPw.println("<vector>");
      for (Iterator operIter = operandsList.iterator();operIter.hasNext();) {
	xmlPw.println("<condition>");
	xmlPw.println("\t<parameter> "+operIter.next()+" </parameter>");
	xmlPw.println("\t<value> "+valueIn.getElementAt(count)+" </value>");
	xmlPw.println("</condition>");
      } // end of for (Iterator operIter = operandsList.iterator();operIter.hasNext();)
      xmlPw.println("<condition>");
      xmlPw.println("\t<parameter> "+operandIn.getLeftOperand()+" </parameter>");
      xmlPw.println("\t<value> "+valueIn.getElementAt(count)+" </value>");
      xmlPw.println("</condition>");
      xmlPw.println("</vector>");
    } // end of for (int count = 0; count < valueIn.size(); count++)

  }
}

    
  //  public void buildVectors(LinkedList finalList,PrintWriter pw, PrintWriter xmlPw) throws FileNotFoundException {

//      int xmlCount = 1;
//      xmlPw.println("<vectorslist>");
    
//      Set inputs_set = inputs.entrySet();
//      Iterator inputs_set_iter = inputs_set.iterator();
    
//      //These two are declared here because their scope will be 
//      //limited if they are declared in the for loop.
//      String input_key_outer = null;
//      String input_key_inner = null;
//      int var_outer = 0;
//      int var_inner = 0;
    
//      //This is used for the parameters in the outer loop.
//      Map.Entry input_entry = (Map.Entry)inputs_set_iter.next();
//      System.out.println("The key is: "+input_entry.getKey());
//      input_key_outer = (String)input_entry.getKey();
//      LinkedList input_value = (LinkedList)input_entry.getValue();
//      System.out.println("I am in Sets.The value is: "+input_value);

//     //   if (inputs_set_iter.hasNext()) {
      
//  //        //This is used for the parameters in the inner loop.
//  //        Map.Entry input_entry_inner = (Map.Entry)inputs_set_iter.next();
//  //        input_key_inner = (String)input_entry_inner.getKey();
//  //        LinkedList input_value_inner = (LinkedList)input_entry_inner.getValue();
//  //        int initial_inner = (new Integer(input_value_inner.get(0).toString())).intValue();
//  //        int final_inner = (new Integer(input_value_inner.get(1).toString())).intValue();
//  //        int increment_inner = (new Integer(input_value_inner.get(2).toString())).intValue();

//  //        //This one is the outer loop which takes care of the first operand.
//  //       for (var_outer = input_value.get(0);var_outer <= input_value.get(1);var_outer = var_outer+input_value.get(2)) {
//  //         //if (inputs_set_iter.hasNext()) {
       
//  //         //This is the inner loop which takes care of the second operand.
//  //         for (var_inner  = initial_inner;var_inner <= final_inner;var_inner = var_inner+increment_inner) {
	 
//  //  	 for (Iterator outerIter = finalList.iterator();outerIter.hasNext();) {
//  //  	   LinkedList innerList = (LinkedList)outerIter.next();
	   
//  //  	   for (Iterator innerIter = innerList.iterator();innerIter.hasNext();) {
//  //  	     Application app = (Application)innerIter.next();
	     
//  //  	     //This hashmap stores all the input variables 
//  //  	     //and the values corresponding to them for this loop.
//  //  	     HashMap ipts = new HashMap();
//  //  	     ipts.put(input_key_outer,Integer.toBinaryString(var_outer));
//  //  	     ipts.put(input_key_inner,Integer.toBinaryString(var_inner));
	     
	     
//  //  	     //The following statements sends the expression and the 
//  //  	     //values associated with the input variables.
//  //  	     evaluateExpression(app,ipts,pw,xmlPw,xmlCount);	       
	     
//  //  	   }
//  //  	 }
//  //         }
//  //         xmlCount++;
//  //         pw.println();
//  //         //}
//  //       }
//  //     }
//      //      else {
//        for (var_outer = getInt(input_value.get(1));var_outer <= getInt(input_value.get(2));var_outer = var_outer+getInt(input_value.get(3))) {
       
//  	for (Iterator outerIter = finalList.iterator();outerIter.hasNext();) {
//  	 LinkedList innerList = (LinkedList)outerIter.next();
	 
//  	 for (Iterator innerIter = innerList.iterator();innerIter.hasNext();) {
//  	   Application app = (Application)innerIter.next();

	   
//  	   //This hashmap stores all the input variables 
//  	   //and the values corresponding to them for this loop.
//  	   HashMap ipts = new HashMap();
//  	   ipts.put(input_key_outer,input_value.get(0));
	   
//  	   //The following statements sends the expression and the 
//  	   //values associated with the input variables.
//  	   evaluateExpression(app,ipts,pw,xmlPw,xmlCount);	
//  	 } // end of else
 
//  	}
//  	xmlCount++;
//        }
//        //}
//      xmlPw.println("</vectorslist>");
//    }

//    public int getInt(Object objIn) {
//      return (new Integer(objIn.toString())).intValue();
//    }

//   public void evaluateExpression(Application appIn,HashMap ipt_var_values,PrintWriter text,PrintWriter xmlPwIn,int xmlCountIn) {

//      String value = appIn.toString();
//      System.out.println("The initial string is: "+value);

//      DVTGScanner parser = new DVTGScanner(value);
//      try {
//        Container cont = parser.scan();       
//        //cont.display();

//        //This gets the operands from the container.
//        Operand operand = cont.getOperands();
//        LinkedList operandsList = operand.getOperands();
//        System.out.println("The original operands are: "+operandsList);
      
//        //This gets the operators from the container.
//        Operator operator = cont.getOperators();
//        LinkedList operatorsList = operator.getOperatorList();
//        System.out.println("The operators size: "+operatorsList.size());

//        //This case deals when there are no operators.
//        if (operatorsList.size() == 0) {

//  	String finalValue = (String)operandsList.getFirst().toString();
//  	System.out.println("The final value is: "+finalValue);

//  	Object final_value = ipt_var_values.get(finalValue);
//  	System.out.println("The final_value is: "+final_value.getClass().getName());
//  	BitSet final_bitset = Identifier.toBitSet((String)final_value);
	
//  	printWaves(text,ipt_var_values,final_value,operand);
//  	//printXml(xmlPwIn,ipt_var_values,final_value,operand,xmlCountIn);
//        } // end of if (operatorsList.size() == 0)

//      } catch (ParseException  e) {
//        System.out.println("Parse Exception: "+e);
//      } // end of try-catch
//   }

//   public void printWaves(PrintWriter textIn,HashMap iptsIn,Object outputIn,Operand operandIn) {
//      System.out.println("I am into PrintWaves");
//      Set iptSet = iptsIn.entrySet();
//      Iterator iptSetIter = iptSet.iterator();

//      while (iptSetIter.hasNext()) {
//        Map.Entry iptSetEntry = (Map.Entry)iptSetIter.next();
//        textIn.print(iptSetEntry.getKey()+" = "+iptSetEntry.getValue());
//      } // end of while (iptSetIter.hasNext())
    
//      textIn.print("\t"+operandIn.getLeftOperand()+" = "+outputIn);
//   }
//  }



