//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: Identifier.java,v 1.2 2002/10/22 20:17:55 cvs Exp $
//
// Revision History:
// ----------------
// $Log: Identifier.java,v $
// Revision 1.2  2002/10/22 20:17:55  cvs
// Made some minor changes while printing the scenarios file.Included all the conditions in the terms in parenthesis.
// --Murthy.
//
// Revision 1.1  2002/09/27 05:20:43  cvs
// This is the intermediate storage for the DVTGScanner.The coming objects IntegerLiterals and CharacterLiterals will be here.
// --Murthy.
//

package org.sldl.rosetta.tools.generatedata.values;

import java.util.BitSet;

/**
 * Describe class <code>Identifier</code> here.
 *
 * @author <a href="mailto:ksatya@ittc.ku.edu">Murthy Kakarlamudi</a>
 * @version 1.0
 */
public class Identifier extends Object {
  
  private String value;

  /**
   * Creates a new <code>Identifier</code> instance.
   *
   * @param valueIn a <code>String</code> value
   */
  public Identifier(String valueIn) {
    value = valueIn;
  }

  /**
   * Describe <code>toString</code> method here.
   *
   * @return a <code>String</code> value
   */
  public String toString() {
    return value;
  }

  /**
   * Describe <code>toBitSet</code> method here.
   *
   * @param valueIn a <code>String</code> value
   * @return a <code>BitSet</code> value
   */
  public static BitSet toBitSet(String valueIn){

    BitSet set = new BitSet();
    String newStr = "";
   
    //This piece of code is used to generate the bits from 
    //the string.for example if the value is {1,0,1,0} this
    //code generates a new string of the form 1010.
    //  for (int count = 1; count < valueIn.length(); count++) {
//        char ch = valueIn.charAt(count);
//        Character chr = new Character(ch);
//        if ((chr.toString()).equalsIgnoreCase("1") || (chr.toString()).equalsIgnoreCase("0")) {
//  	newStr = newStr+chr.toString();
//        } // end of if ((chr.toString()).equalsIgnoreCase("1"))
//      } // end of for (int count = 0; count < value.length(); count++)

    //This code sets the bits to true in the bitset.
    //System.out.println("in Identifier valueIn: "+valueIn);
    for (int cnt = valueIn.length(); cnt>0;cnt--) {
      char chr_tmp = valueIn.charAt(cnt - 1);
      Character chr_wrap = new Character(chr_tmp);
      if ((chr_wrap.toString()).equalsIgnoreCase("1")) {
	set.set(valueIn.length() - cnt);
      } // end of if ((chr_wrap.toString()).equalsIgnoreCase("1"))
    } // end of for (int count = newStr.length(); count>0;count--)

    return set;
  }

}
