//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: SymbolTableEntry.java,v 1.1.1.1 2002/07/01 15:47:36 cvs Exp $
//
// Revision History:
// ----------------
// $Log: SymbolTableEntry.java,v $
// Revision 1.1.1.1  2002/07/01 15:47:36  cvs
// Rosetta tools and publications repository
//
// Revision 1.1.2.1  2002/03/12 22:27:22  cvs
// Added a linker that uses the multi-dispatch visitor.
// -kimmell
//
package org.sldl.rosetta.tools.glinker;

/**
 * SymbolTableEntry.java
 *
 *
 * Created: Wed Feb  6 10:44:54 2002
 *
 * @author <a href="mailto:kimmell@ku.edu">Garrin Kimmell</a>
 * @version
 */

import org.sldl.rosetta.ROM.Item;

public class SymbolTableEntry {

  private Item value;
  private SymbolTable symbolTable;
  private boolean visited;

  public SymbolTableEntry (){
    value = null;
    symbolTable = null;
    visited = false;
  }

  public SymbolTableEntry (Item argValue){
    value = argValue;
    symbolTable = null;
    visited = false;
  }

  public SymbolTableEntry(Item argValue, SymbolTable argSymbolTable) {
    value = argValue;
    symbolTable = argSymbolTable;
    visited = false;
  }

  public SymbolTableEntry(Item argValue, SymbolTable argSymbolTable,
			  boolean argVisited) {

    value = argValue;
    symbolTable = argSymbolTable;
    visited = argVisited;
  }
 
  
  /**
   * Gets the value of value
   *
   * @return the value of value
   */
  public Item getValue() {
    return this.value;
  }

  /**
   * Sets the value of value
   *
   * @param argValue Value to assign to this.value
   */
  public void setValue(Item argValue){
    this.value = argValue;
  }

  /**
   * Gets the value of symbolTable
   *
   * @return the value of symbolTable
   */
  public SymbolTable getSymbolTable() {
    return this.symbolTable;
  }

  /**
   * Sets the value of symbolTable
   *
   * @param argSymbolTable Value to assign to this.symbolTable
   */
  public void setSymbolTable(SymbolTable argSymbolTable){
    this.symbolTable = argSymbolTable;
  }

  public String toString() {
      
    String str = "";
    if (value.getType() == null) {
      str = str + "unknown";
    } else {
      str = str + value.getType();
    } // end of else
    
    if (value.getValue() != null) {
      str = str + " is-a " + value.getValue().getClass().getName();
    } else { 
      str = str + " has no value";
    }
    
    return str;
  }
  
  public void print(String tabs) {
    if (symbolTable != null) {
      System.out.println(tabs + "SymbolTable:\n" + tabs + "--------------");
      symbolTable.print(tabs + "|    ");
      System.out.println(tabs + "--------------------");
    }
    
  }
    
    

}// SymbolTableEntry
