//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: IdentityAlgorithm.java,v 1.1.1.1 2002/07/01 15:47:38 cvs Exp $
//
// Revision History:
// ----------------
// $Log: IdentityAlgorithm.java,v $
// Revision 1.1.1.1  2002/07/01 15:47:38  cvs
// Rosetta tools and publications repository
//
// Revision 1.1.2.1  2002/04/04 20:10:54  cvs
// Added the identity algorithm for checking TCCs of the form isCompatable(int,int).
// -kimmell
//
package org.sldl.rosetta.tools.typechecker.algorithms;

/**
 * IdentityAlgorithm.java
 *
 *
 * Created: Tue Mar 19 12:26:33 2002
 *
 * @author <a href="mailto:kimmell@ku.edu">Garrin Kimmell</a>
 * @version
 */

import org.sldl.rosetta.tools.propertychecker.PropertyChecker;
import org.sldl.rosetta.tools.propertychecker.PropertyCheckCondition;
import org.sldl.rosetta.tools.propertychecker.PropertyCheckAlgorithm;

import org.sldl.rosetta.tools.typechecker.conditions.TypeCompatabilityCondition;

public class IdentityAlgorithm extends PropertyCheckAlgorithm {
  public IdentityAlgorithm (){
    
  }
  
  public int checkCondition(PropertyCheckCondition pcc) {
    if (pcc instanceof TypeCompatabilityCondition) {
      TypeCompatabilityCondition tcc = (TypeCompatabilityCondition)
	pcc;
      if (tcc.getFormal() == tcc.getActual()) {
	System.out.println("Resolved " + tcc);
	return PropertyChecker.PROPERTY_TRUE;
      } else {
	System.out.println("Could not resolve " + tcc);
	return PropertyChecker.PROPERTY_UNKNOWN;
	
      } // end of else
     
    } // end of if (pcc instanceof TypeCompatabilityCondition)
    else {
      return PropertyChecker.PROPERTY_UNKNOWN;
    } // end of if (pcc instanceof TypeCompatabilityCondition)else
    

  }
  
}// IdentityAlgorithm
