//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: TypeEquivalenceAlgorithm.java,v 1.2 2002/07/08 21:14:18 kimmell Exp $
//
// Revision History:
// ----------------
// $Log: TypeEquivalenceAlgorithm.java,v $
// Revision 1.2  2002/07/08 21:14:18  kimmell
// 1. Removed reliance on matches() method of objects.
// 2. Using pointer equality to determine if two objects are of
// equivalent types - this is too strong of a condition, and should be
// changed to using structural equality.
//
// -kimmell
//
// Revision 1.1.1.1  2002/07/01 15:47:38  cvs
// Rosetta tools and publications repository
//
// Revision 1.1.2.1  2002/03/12 22:29:40  cvs
// Added the typechecker which uses the multivisitor class and the propertycheck framework.
// -kimmell
//
package org.sldl.rosetta.tools.typechecker.algorithms;

/**
 * TypeEquivalenceAlgorithm.java
 *
 *
 * Created: Mon Feb 25 16:34:48 2002
 *
 * @author <a href="mailto:kimmell@ku.edu">Garrin Kimmell</a>
 * @version
 */

import
  org.sldl.rosetta.tools.typechecker.conditions.TypeCompatabilityCondition;
import org.sldl.rosetta.tools.propertychecker.*;

import org.sldl.rosetta.ROM.BaseObject;

public class TypeEquivalenceAlgorithm extends PropertyCheckAlgorithm {

  public TypeEquivalenceAlgorithm() {
  
  }

  public int checkCondition(PropertyCheckCondition cond) {
    if (cond instanceof TypeCompatabilityCondition) {
      BaseObject formal = ((TypeCompatabilityCondition)
			   cond).getFormal();
      BaseObject actual = ((TypeCompatabilityCondition)
			   cond).getActual();
      // FIXME: This condition is way to restrictive - it uses
      // reference equality, when it should use structural equality.
      if (formal == actual) {
	return PropertyChecker.PROPERTY_TRUE;
      } // end of if (cond.getFormal().matches(cond.getAcutal()))
      else {
	return PropertyChecker.PROPERTY_UNKNOWN;
      } // end of else
      
      
    } else {
      return PropertyChecker.PROPERTY_UNKNOWN;
    } // end of else
    
    
  }    
  
}// TypeEquivalenceAlgorithm
