//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: TypeExistenceAlgorithm.java,v 1.1.1.1 2002/07/01 15:47:38 cvs Exp $
//
// Revision History:
// ----------------
// $Log: TypeExistenceAlgorithm.java,v $
// Revision 1.1.1.1  2002/07/01 15:47:38  cvs
// Rosetta tools and publications repository
//
// Revision 1.1.2.1  2002/03/12 22:29:40  cvs
// Added the typechecker which uses the multivisitor class and the propertycheck framework.
// -kimmell
//
package org.sldl.rosetta.tools.typechecker.algorithms;

import org.sldl.rosetta.tools.propertychecker.PropertyChecker;
import org.sldl.rosetta.tools.propertychecker.PropertyCheckAlgorithm;
import org.sldl.rosetta.tools.propertychecker.PropertyCheckCondition;
import org.sldl.rosetta.tools.typechecker.conditions.TypeExistenceCondition;

/**
 * TypeExistenceAlgorithm.java
 *
 *
 * Created: Mon Feb 25 16:24:24 2002
 *
 * @author <a href="mailto:kimmell@ku.edu">Garrin Kimmell</a>
 * @version
 */

public class TypeExistenceAlgorithm extends PropertyCheckAlgorithm {
  public TypeExistenceAlgorithm (){
    
  }
  
  public int checkCondition(PropertyCheckCondition cond) {
    if (cond instanceof TypeExistenceCondition) {
      return PropertyChecker.PROPERTY_TRUE;
    } else {
      return PropertyChecker.PROPERTY_UNKNOWN;
    } // end of else
  }
    
  
}// TypeExistenceAlgorithm
