//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: ExistenceCondition.java,v 1.1.1.1 2002/07/01 15:47:38 cvs Exp $
//
// Revision History:
// ----------------
// $Log: ExistenceCondition.java,v $
// Revision 1.1.1.1  2002/07/01 15:47:38  cvs
// Rosetta tools and publications repository
//
// Revision 1.1.2.1  2002/03/12 22:29:41  cvs
// Added the typechecker which uses the multivisitor class and the propertycheck framework.
// -kimmell
//
package org.sldl.rosetta.tools.typechecker.conditions;

/**
 * ExistenceCondition.java
 *
 *
 * Created: Mon Mar  4 14:19:46 2002
 *
 * @author <a href="mailto:kimmell@ku.edu">Garrin Kimmell</a>
 * @version
 */

import org.sldl.rosetta.ROM.Label;
import org.sldl.rosetta.ROM.TypeExpression;

public class ExistenceCondition extends TypeCheckCondition {
  
  private TypeExpression type;
  private Label label;

  public ExistenceCondition(TypeExpression argType) {
    type = argType;
    label = new Label("x");
  }

  public ExistenceCondition(Label argLabel, TypeExpression argType) {
    label = argLabel;
    type = argType;
  }

  /**
   * Gets the value of type
   *
   * @return the value of type
   */
  public TypeExpression getType() {
    return this.type;
  }

  /**
   * Sets the value of type
   *
   * @param argType Value to assign to this.type
   */
  public void setType(TypeExpression argType){
    this.type = argType;
  }

  public String toString() {
    return "exists( (" + label + "):: (" + type.toString() + ") | true)";
  }
  
}// ExistenceCondition
