//============================================================================
//  Copyright (c) 2000 University of Kansas
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//
// $Id: TypeCompatabilityCondition.java,v 1.1.1.1 2002/07/01 15:47:38 cvs Exp $
//
// Revision History:
// ----------------
// $Log: TypeCompatabilityCondition.java,v $
// Revision 1.1.1.1  2002/07/01 15:47:38  cvs
// Rosetta tools and publications repository
//
// Revision 1.1.2.1  2002/03/12 22:29:42  cvs
// Added the typechecker which uses the multivisitor class and the propertycheck framework.
// -kimmell
//
package org.sldl.rosetta.tools.typechecker.conditions;

import org.sldl.rosetta.ROM.BaseObject;

/**
 * TypeCompatabilityCondition.java
 *
 *
 * Created: Mon Feb 25 16:07:13 2002
 *
 * @author <a href="mailto:kimmell@ku.edu">Garrin Kimmell</a>
 * @version
 */

public class TypeCompatabilityCondition extends TypeCheckCondition {
  private BaseObject formal;
  private BaseObject actual;

  public TypeCompatabilityCondition (BaseObject argFormal, 
				     BaseObject argActual){    
    formal = argFormal;
    actual = argActual;
  }


  public String toString() {
    String str = "TCC: isCompatable(";
    str = str + actual + ", " + formal + ")";
    return str;
  }
  

  /**
   * Gets the value of formal
   *
   * @return the value of formal
   */
  public BaseObject getFormal() {
    return this.formal;
  }

  /**
   * Sets the value of formal
   *
   * @param argFormal Value to assign to this.formal
   */
  public void setFormal(BaseObject argFormal){
    this.formal = argFormal;
  }

  /**
   * Gets the value of actual
   *
   * @return the value of actual
   */
  public BaseObject getActual() {
    return this.actual;
  }

  /**
   * Sets the value of actual
   *
   * @param argActual Value to assign to this.actual
   */
  public void setActual(BaseObject argActual){
    this.actual = argActual;
  }


  
  
}// TypeCompatabilityCondition
