#!/usr/bin/perl
#============================================================================
#  Copyright (c) 2000 University of Kansas 
#  All rights reserved.
#
#  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
#  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
#  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
#  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
#  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
#  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
#
#
#  By using or copying this Software, Licensee agrees to abide by the
#  intellectual property laws, and all other applicable laws of the
#  U.S., and the terms of this license.
#
#	authors: Srinivas (akki@ittc.ukans.edu)
#
#  $Id: test.pl,v 1.9 2002/07/30 15:35:03 kimmell Exp $
#
#  Revision History:
#  ----------------
#  $Log: test.pl,v $
#  Revision 1.9  2002/07/30 15:35:03  kimmell
#  Fixed a syntax bug in the test script.
#  -kimmell
#
#  Revision 1.8  2002/07/30 15:30:58  kimmell
#  Added the java bin directory to the PATH environment variable so that cron will execute the tests.
#  -kimmell
#
#  Revision 1.7  2002/07/12 15:19:22  kimmell
#  1. Added JAVA_HOME, JAVACC_HOME, SLDL_HOME environment variables to the test script.
#
#  These are KU-specific directories, and will need to be changed outside KU.
#  -kimmell
#
#  Revision 1.6  2002/07/08 22:23:20  kimmell
#  1. Set the mailing of test results to the sldg group.
#  -kimmell
#
#  Revision 1.5  2002/07/08 22:13:21  kimmell
#  1. Fixed perl syntax error.
#  -kimmell
#
#  Revision 1.4  2002/07/08 22:11:14  kimmell
#  1. Set the SLDL_HOME environment variable
#
#  -kimmell
#
#  Revision 1.3  2002/07/08 21:43:57  kimmell
#  1. Fixed a bug with pathnames.
#  -kimmell
#
#  Revision 1.2  2002/07/08 21:37:53  kimmell
#  1. Changed test script to reflect restructuring of the CVS repository.
#  -kimmell
#
#  Revision 1.1.1.1  2002/07/01 15:47:34  cvs
#  Rosetta tools and publications repository
#
#  Revision 1.2  2000/03/07 00:48:54  cvs
#  Changing the user id to sldg group so that everyone receives the mail
#  --srinivas
#
#  Revision 1.1  2000/03/07 00:42:15  cvs
#  The script that runs the regression tests daily .It has the following options
#  	-do_update
#  	-force_update
#  	-query_update
#  	--srinivas
#
#
#
#=============================================================================
#
# Global flags
#
use Cwd;
$updateExpected = "false";
         
#
# Process Arguments
#      
@ARGV = ('-') unless @ARGV;
while($ARGV = shift){
    if($ARGV =~ /-force_update/){
        $updateExpected = "force";
    } elsif($ARGV =~ /-query_update/){
        $updateExpected = "query";
    } elsif ($ARGV =~ /-do_update/){
        $updateExpected = "do";
        }
}


# Set up appropriate environment variables
$sldlhome = "/projects/sldg/sldl/unstable/Rosetta/tools";
$javahome = "/tools/java/i686/jdk1.2.2";
$javacchome = "/tools/javacc";
$ENV{"SLDL_HOME"} = $sldlhome;
$ENV{"JAVA_HOME"} = $javahome;
$ENV{"JAVACC_HOME"} = $javacchome;
$path=$ENV{"PATH"};
$ENV{"PATH"} = "$path:$javahome/bin";


chdir ($sldlhome);
$s1 = system ('cvs -d /projects/sldg/CVS update -d');
chdir ($sldlhome) or die
"Can't chdir to tools directory";
$s2 = system ('make clean');
$s3 =system ('make');
chdir ("$sldlhome/test") or die
"Can't chdir to test directory" ;
if ($updateExpected eq "false"){
$s4 = system ('perl sldltest.pl ');
}elsif ($updateExpected eq "force"){
$s4 = system ('perl sldltest.pl -force_update');
}elsif ($updateExpected eq "query"){
$s4 = system ('perl sldltest.pl -query_update');
}elsif ($updateExpected eq "do"){
$s4 = system ('perl sldltest.pl -do_update');
}
$s5 = system ('mail  -s "RT: Rosetta Parser Test Results" sldg < test.results');

 
